
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega88P
;Program type             : Application
;Clock frequency          : 10,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88P
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rx_wr_index0=R4
	.DEF _rx_rd_index0=R3
	.DEF _rx_counter0=R6
	.DEF _data_rf=R5
	.DEF _rfxx_flag=R8
	.DEF _status_rf=R9
	.DEF _i=R7
	.DEF _w0=R12
	.DEF _w1=R11
	.DEF _speed=R14
	.DEF _sost=R13

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _usart_rx_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x1B:
	.DB  0x10
_0x5B:
	.DB  0x1,0x0,0x0,0x0,0x0,0x80,0x10
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _direct
	.DW  _0x1B*2

	.DW  0x07
	.DW  0x08
	.DW  _0x5B*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,0x00
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x4FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x4FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x200)
	LDI  R29,HIGH(0x200)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200

	.CSEG
;/*****************************************************
;Chip type               : ATmega88P
;AVR Core Clock frequency: 13,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;
;
;#define DDR_SS DDRB
;#define DDR_SCK DDRB
;#define DDR_MOSI DDRB
;#define PORT_SS PORTB
;#define PORT_SCK PORTB
;#define PORT_MOSI PORTB
;#define PIN_MISO PINB
;#define PIN_IRQ PIND
;#define SS 2
;#define SCK 5
;#define MOSI 3
;#define MISO 4
;#define IRQ 2
;
;#include <mega88p.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include <stdlib.h>
;#include <delay.h>
;
;
;#ifndef RXB8
;#define RXB8 1
;#endif
;
;#ifndef TXB8
;#define TXB8 0
;#endif
;
;#ifndef UPE
;#define UPE 2
;#endif
;
;#ifndef DOR
;#define DOR 3
;#endif
;
;#ifndef FE
;#define FE 4
;#endif
;
;#ifndef UDRE
;#define UDRE 5
;#endif
;
;#ifndef RXC
;#define RXC 7
;#endif
;
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;
;// USART Receiver buffer
;#define RX_BUFFER_SIZE0 32
;char rx_buffer0[RX_BUFFER_SIZE0];
;
;#if RX_BUFFER_SIZE0<256
;unsigned char rx_wr_index0,rx_rd_index0,rx_counter0;
;#else
;unsigned int rx_wr_index0,rx_rd_index0,rx_counter0;
;#endif
;
;// This flag is set on USART Receiver buffer overflow
;bit rx_buffer_overflow0;
;
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 004F {

	.CSEG
_usart_rx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0050 char status,data;
; 0000 0051 status=UCSR0A;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	LDS  R17,192
; 0000 0052 data=UDR0;
	LDS  R16,198
; 0000 0053 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
; 0000 0054    {
; 0000 0055    rx_buffer0[rx_wr_index0]=data;
	MOV  R30,R4
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_rx_buffer0)
	SBCI R31,HIGH(-_rx_buffer0)
	ST   Z,R16
; 0000 0056    if (++rx_wr_index0 == RX_BUFFER_SIZE0) rx_wr_index0=0;
	INC  R4
	LDI  R30,LOW(32)
	CP   R30,R4
	BRNE _0x4
	CLR  R4
; 0000 0057    if (++rx_counter0 == RX_BUFFER_SIZE0)
_0x4:
	INC  R6
	LDI  R30,LOW(32)
	CP   R30,R6
	BRNE _0x5
; 0000 0058       {
; 0000 0059       rx_counter0=0;
	CLR  R6
; 0000 005A       rx_buffer_overflow0=1;
	SBI  0x1E,0
; 0000 005B       };
_0x5:
; 0000 005C    };
_0x3:
; 0000 005D }
	RCALL __LOADLOCR2P
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Get a character from the USART Receiver buffer
;#define _ALTERNATE_GETCHAR_
;#pragma used+
;char getchar(void)
; 0000 0064 {
; 0000 0065 char data;
; 0000 0066 while (rx_counter0==0);
;	data -> R17
; 0000 0067 data=rx_buffer0[rx_rd_index0];
; 0000 0068 if (++rx_rd_index0 == RX_BUFFER_SIZE0) rx_rd_index0=0;
; 0000 0069 #asm("cli")
; 0000 006A --rx_counter0;
; 0000 006B #asm("sei")
; 0000 006C return data;
; 0000 006D }
;#pragma used-
;#endif
;
;// Standard Input/Output functions
;#include <stdio.h>
;
;#define ADC_VREF_TYPE 0x60
;
;// Read the 8 most significant bits
;// of the AD conversion result
;unsigned char read_adc(unsigned char adc_input)
; 0000 0079 {
_read_adc:
; 0000 007A ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,LOW(0x60)
	STS  124,R30
; 0000 007B // Delay needed for the stabilization of the ADC input voltage
; 0000 007C delay_us(10);
	__DELAY_USB 33
; 0000 007D // Start the AD conversion
; 0000 007E ADCSRA|=0x40;
	LDS  R30,122
	ORI  R30,0x40
	STS  122,R30
; 0000 007F // Wait for the AD conversion to complete
; 0000 0080 while ((ADCSRA & 0x10)==0);
_0xC:
	LDS  R30,122
	ANDI R30,LOW(0x10)
	BREQ _0xC
; 0000 0081 ADCSRA|=0x10;
	LDS  R30,122
	ORI  R30,0x10
	STS  122,R30
; 0000 0082 return ADCH;
	LDS  R30,121
	RJMP _0x20A0002
; 0000 0083 }
;
;// rf 
;
;unsigned char data_rf,rfxx_flag=1;
;unsigned int status_rf;
;unsigned int RFXX_WRT_CMD(unsigned int aCmd) // 
; 0000 008A {
_RFXX_WRT_CMD:
; 0000 008B unsigned char i;
; 0000 008C unsigned int temp=0;
; 0000 008D PORT_SCK&=~(1<<SCK);
	RCALL __SAVELOCR4
;	aCmd -> Y+4
;	i -> R17
;	temp -> R18,R19
	__GETWRN 18,19,0
	CBI  0x5,5
; 0000 008E PORT_SS&=~(1<<SS);
	CBI  0x5,2
; 0000 008F for(i=0;i<16;i++)
	LDI  R17,LOW(0)
_0x10:
	CPI  R17,16
	BRSH _0x11
; 0000 0090    {
; 0000 0091    if(aCmd&0x8000) PORT_MOSI|=(1<<MOSI);
	LDD  R30,Y+5
	ANDI R30,LOW(0x80)
	BREQ _0x12
	SBI  0x5,3
; 0000 0092    else PORT_MOSI&=~(1<<MOSI);
	RJMP _0x13
_0x12:
	CBI  0x5,3
; 0000 0093    PORT_SCK|=(1<<SCK);
_0x13:
	SBI  0x5,5
; 0000 0094    temp<<=1;
	LSL  R18
	ROL  R19
; 0000 0095    if(PIN_MISO&(1<<MISO)) temp|=0x0001;
	SBIC 0x3,4
	ORI  R18,LOW(1)
; 0000 0096    PORT_SCK&=~(1<<SCK);
	CBI  0x5,5
; 0000 0097    aCmd<<=1;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LSL  R30
	ROL  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 0098    }
	SUBI R17,-1
	RJMP _0x10
_0x11:
; 0000 0099 PORT_SS|=(1<<SS);
	SBI  0x5,2
; 0000 009A return(temp);
	MOVW R30,R18
	RCALL __LOADLOCR4
	ADIW R28,6
	RET
; 0000 009B }
;
;void RF12_SEND(unsigned char aByte)
; 0000 009E {
_RF12_SEND:
; 0000 009F while(!(RFXX_WRT_CMD(0x0000)&0x8000));
;	aByte -> Y+0
_0x15:
	RCALL SUBOPT_0x1
	ANDI R31,HIGH(0x8000)
	BREQ _0x15
; 0000 00A0 RFXX_WRT_CMD(0xB800+aByte);
	LD   R30,Y
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-47104)
	SBCI R31,HIGH(-47104)
	RCALL SUBOPT_0x2
; 0000 00A1 }
_0x20A0002:
	ADIW R28,1
	RET
;
;void RF12_INIT(void) //
; 0000 00A4 {
_RF12_INIT:
; 0000 00A5 DDR_SS|=(1<<SS);
	SBI  0x4,2
; 0000 00A6 DDR_SCK|=(1<<SCK);
	SBI  0x4,5
; 0000 00A7 DDR_MOSI|=(1<<MOSI);
	SBI  0x4,3
; 0000 00A8 PORT_SS|=(1<<SS);
	SBI  0x5,2
; 0000 00A9 while (!PIND.2) RFXX_WRT_CMD(0x0000);
_0x18:
	SBIC 0x9,2
	RJMP _0x1A
	RCALL SUBOPT_0x1
	RJMP _0x18
_0x1A:
; 0000 00AB RFXX_WRT_CMD(0x80E7);
	RCALL SUBOPT_0x3
; 0000 00AC RFXX_WRT_CMD(0x8219);//!er,!ebb,!ET,ES,EX,!eb,!ew,DC
	LDI  R30,LOW(33305)
	LDI  R31,HIGH(33305)
	RCALL SUBOPT_0x2
; 0000 00AD RFXX_WRT_CMD(0xA640);//=868MHz
	LDI  R30,LOW(42560)
	LDI  R31,HIGH(42560)
	RCALL SUBOPT_0x2
; 0000 00AE RFXX_WRT_CMD(0xC647);//06->57.6kbps 47->4.8kbps
	LDI  R30,LOW(50759)
	LDI  R31,HIGH(50759)
	RCALL SUBOPT_0x2
; 0000 00AF RFXX_WRT_CMD(0x94C0);//VDI,FAST,67kHz,0dBm,-103dBm
	LDI  R30,LOW(38080)
	LDI  R31,HIGH(38080)
	RCALL SUBOPT_0x2
; 0000 00B0 RFXX_WRT_CMD(0xC2AC);//AL,!ml,DIG,DQD4
	LDI  R30,LOW(49836)
	LDI  R31,HIGH(49836)
	RCALL SUBOPT_0x2
; 0000 00B1 RFXX_WRT_CMD(0xCAB0);//FIFO11,SYNC,!ff,DR
	LDI  R30,LOW(51888)
	LDI  R31,HIGH(51888)
	RCALL SUBOPT_0x2
; 0000 00B2 RFXX_WRT_CMD(0xC4F3);//@PWR,NO RSTRIC,!st,!fi,OE,EN
	LDI  R30,LOW(50419)
	LDI  R31,HIGH(50419)
	RCALL SUBOPT_0x2
; 0000 00B3 RFXX_WRT_CMD(0x9820);//!mp,45kHz,MAX OUT
	LDI  R30,LOW(38944)
	LDI  R31,HIGH(38944)
	RCALL SUBOPT_0x2
; 0000 00B4 RFXX_WRT_CMD(0xCC07);
	LDI  R30,LOW(52231)
	LDI  R31,HIGH(52231)
	RCALL SUBOPT_0x2
; 0000 00B5 RFXX_WRT_CMD(0xE000);//NOT USE
	LDI  R30,LOW(57344)
	LDI  R31,HIGH(57344)
	RCALL SUBOPT_0x2
; 0000 00B6 RFXX_WRT_CMD(0xC800);//NOT USE
	LDI  R30,LOW(51200)
	LDI  R31,HIGH(51200)
	RCALL SUBOPT_0x2
; 0000 00B7 RFXX_WRT_CMD(0xC000);//1MHz,2.2V
	LDI  R30,LOW(49152)
	LDI  R31,HIGH(49152)
	RJMP _0x20A0001
; 0000 00B8 }
;
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 00BD {
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00BE status_rf=RFXX_WRT_CMD(0x0000);
	RCALL SUBOPT_0x1
	__PUTW1R 9,10
; 0000 00BF data_rf=(char)((RFXX_WRT_CMD(0xB000))&0x00FF);
	LDI  R30,LOW(45056)
	LDI  R31,HIGH(45056)
	RCALL SUBOPT_0x2
	MOV  R5,R30
; 0000 00C0 rfxx_flag=0;
	CLR  R8
; 0000 00C1 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;void fifo_reset(void)
; 0000 00C4   {
_fifo_reset:
; 0000 00C5   RFXX_WRT_CMD(0xCAB0);
	LDI  R30,LOW(51888)
	LDI  R31,HIGH(51888)
	RCALL SUBOPT_0x2
; 0000 00C6   RFXX_WRT_CMD(0xCAB2);
	LDI  R30,LOW(51890)
	LDI  R31,HIGH(51890)
	RJMP _0x20A0001
; 0000 00C7   }
;
;void RF12_tx_on(void)
; 0000 00CA   {
_RF12_tx_on:
; 0000 00CB    RFXX_WRT_CMD(0x80E7);
	RCALL SUBOPT_0x3
; 0000 00CC    RFXX_WRT_CMD(0x8239);
	LDI  R30,LOW(33337)
	LDI  R31,HIGH(33337)
_0x20A0001:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _RFXX_WRT_CMD
; 0000 00CD   }
	RET
;
;void RF12_rx_on(void)
; 0000 00D0   {
_RF12_rx_on:
; 0000 00D1    RFXX_WRT_CMD(0x80E7);
	RCALL SUBOPT_0x3
; 0000 00D2    RFXX_WRT_CMD(0x8299);
	LDI  R30,LOW(33433)
	LDI  R31,HIGH(33433)
	RCALL SUBOPT_0x2
; 0000 00D3    fifo_reset();
	RCALL _fifo_reset
; 0000 00D4   }
	RET
;
;unsigned char i,w0,w1,speed=0x10,sost=0x80,direct=0x10;

	.DSEG
;unsigned char inbuff[7],crc_in;
;
;void rtx_pack (unsigned char ack)
; 0000 00DA   {

	.CSEG
_rtx_pack:
; 0000 00DB    unsigned char crc,ar1,ar2,ar3,ar4;
; 0000 00DC    ar1=read_adc(6);
	RCALL __SAVELOCR6
;	ack -> Y+6
;	crc -> R17
;	ar1 -> R16
;	ar2 -> R19
;	ar3 -> R18
;	ar4 -> R21
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R16,R30
; 0000 00DD    ar2=read_adc(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R19,R30
; 0000 00DE    ar3=read_adc(7);
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R18,R30
; 0000 00DF    ar4=(PORTC&0b00111100)>>2;
	IN   R30,0x8
	ANDI R30,LOW(0x3C)
	RCALL SUBOPT_0x0
	RCALL __ASRW2
	MOV  R21,R30
; 0000 00E0 
; 0000 00E1    crc=sost%0x31;
	MOV  R26,R13
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
; 0000 00E2    crc=(crc+ar1)%0x31;
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	RCALL SUBOPT_0x6
; 0000 00E3    crc=(crc+ar2)%0x31;
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	RCALL SUBOPT_0x6
; 0000 00E4    crc=(crc+ar3)%0x31;
	CLR  R30
	ADD  R26,R18
	ADC  R27,R30
	RCALL SUBOPT_0x6
; 0000 00E5    crc=(crc+ar4)%0x31;
	CLR  R30
	ADD  R26,R21
	ADC  R27,R30
	RCALL SUBOPT_0x6
; 0000 00E6    crc=(crc+ack)%0x31;
	LDD  R30,Y+6
	RCALL SUBOPT_0x7
	MOV  R17,R30
; 0000 00E7   RF12_SEND(0xAA);//PREAMBLE
	RCALL SUBOPT_0x8
; 0000 00E8   RF12_SEND(0xAA);//PREAMBLE
	RCALL SUBOPT_0x8
; 0000 00E9   RF12_SEND(0xAA);//PREAMBLE
	RCALL SUBOPT_0x8
; 0000 00EA   RF12_SEND(0x2D);//SYNC HI BYTE
	LDI  R30,LOW(45)
	RCALL SUBOPT_0x9
; 0000 00EB   RF12_SEND(0xD4);//SYNC LOW BYTE
	LDI  R30,LOW(212)
	RCALL SUBOPT_0x9
; 0000 00EC   RF12_SEND(0x6A);
	LDI  R30,LOW(106)
	RCALL SUBOPT_0x9
; 0000 00ED   RF12_SEND(0x20);
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x9
; 0000 00EE   RF12_SEND(sost);
	ST   -Y,R13
	RCALL _RF12_SEND
; 0000 00EF   RF12_SEND(ar1);
	ST   -Y,R16
	RCALL _RF12_SEND
; 0000 00F0   RF12_SEND(ar2);
	ST   -Y,R19
	RCALL _RF12_SEND
; 0000 00F1   RF12_SEND(ar3);
	ST   -Y,R18
	RCALL _RF12_SEND
; 0000 00F2   RF12_SEND(ar4);
	ST   -Y,R21
	RCALL _RF12_SEND
; 0000 00F3   RF12_SEND(ack);
	LDD  R30,Y+6
	RCALL SUBOPT_0x9
; 0000 00F4   RF12_SEND(crc);
	ST   -Y,R17
	RCALL _RF12_SEND
; 0000 00F5   RF12_SEND(0xAA);//DUMMY BYTE
	RCALL SUBOPT_0x8
; 0000 00F6   RF12_SEND(0xAA);//DUMMY BYTE
	RCALL SUBOPT_0x8
; 0000 00F7   };
	RCALL __LOADLOCR6
	ADIW R28,7
	RET
;
;
;void main(void)
; 0000 00FB {
_main:
; 0000 00FC // Declare your local variables here
; 0000 00FD  unsigned char temp;
; 0000 00FE // Crystal Oscillator division factor: 1
; 0000 00FF #pragma optsize-
; 0000 0100 CLKPR=0x80;
;	temp -> R17
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 0101 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 0102 #ifdef _OPTIMIZE_SIZE_
; 0000 0103 #pragma optsize+
; 0000 0104 #endif
; 0000 0105 
; 0000 0106 // Input/Output Ports initialization
; 0000 0107 PORTB=0x00;DDRB=0x2F;
	OUT  0x5,R30
	LDI  R30,LOW(47)
	OUT  0x4,R30
; 0000 0108 PORTC=0x40;DDRC=0x3E;
	LDI  R30,LOW(64)
	OUT  0x8,R30
	LDI  R30,LOW(62)
	OUT  0x7,R30
; 0000 0109 PORTD=0x0D;DDRD=0xF2;
	LDI  R30,LOW(13)
	OUT  0xB,R30
	LDI  R30,LOW(242)
	OUT  0xA,R30
; 0000 010A 
; 0000 010B // Timer/Counter 0 initialization
; 0000 010C // Clock source: System Clock
; 0000 010D // Clock value: 9,766 kHz
; 0000 010E // Mode: Fast PWM top=FFh
; 0000 010F // OC0A output: Non-Inverted PWM
; 0000 0110 // OC0B output: Non-Inverted PWM
; 0000 0111 TCCR0A=0xA3;TCCR0B=0x05;TCNT0=0x00;
	LDI  R30,LOW(163)
	OUT  0x24,R30
	LDI  R30,LOW(5)
	OUT  0x25,R30
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0112 OCR0A=0xA0;OCR0B=0x60;
	LDI  R30,LOW(160)
	OUT  0x27,R30
	LDI  R30,LOW(96)
	OUT  0x28,R30
; 0000 0113 
; 0000 0114 // Timer/Counter 1 initialization
; 0000 0115 // Clock source: System Clock
; 0000 0116 // Clock value: 10000,000 kHz
; 0000 0117 // Mode: CTC top=OCR1A
; 0000 0118 // OC1A output: Toggle
; 0000 0119 // OC1B output: Discon.
; 0000 011A // Noise Canceler: Off
; 0000 011B // Input Capture on Falling Edge
; 0000 011C // Timer1 Overflow Interrupt: Off
; 0000 011D // Input Capture Interrupt: Off
; 0000 011E // Compare A Match Interrupt: Off
; 0000 011F // Compare B Match Interrupt: Off
; 0000 0120 TCCR1A=0x40;TCCR1B=0x09;TCNT1H=0x00;TCNT1L=0x00;
	LDI  R30,LOW(64)
	STS  128,R30
	LDI  R30,LOW(9)
	STS  129,R30
	LDI  R30,LOW(0)
	STS  133,R30
	STS  132,R30
; 0000 0121 ICR1H=0x00;ICR1L=0x00;
	STS  135,R30
	STS  134,R30
; 0000 0122 OCR1AH=0x27;OCR1AL=0x10;
	LDI  R30,LOW(39)
	STS  137,R30
	LDI  R30,LOW(16)
	STS  136,R30
; 0000 0123 OCR1BH=0x00;OCR1BL=0x00;
	LDI  R30,LOW(0)
	STS  139,R30
	STS  138,R30
; 0000 0124 
; 0000 0125 // Timer/Counter 2 initialization
; 0000 0126 // Clock source: System Clock
; 0000 0127 // Clock value: Timer2 Stopped
; 0000 0128 // Mode: Normal top=FFh
; 0000 0129 // OC2A output: Disconnected
; 0000 012A // OC2B output: Disconnected
; 0000 012B ASSR=0x00;
	STS  182,R30
; 0000 012C TCCR2A=0x00;
	STS  176,R30
; 0000 012D TCCR2B=0x00;
	STS  177,R30
; 0000 012E TCNT2=0x00;
	STS  178,R30
; 0000 012F OCR2A=0x00;
	STS  179,R30
; 0000 0130 OCR2B=0x00;
	STS  180,R30
; 0000 0131 
; 0000 0132 // External Interrupt(s) initialization
; 0000 0133 // INT0: On
; 0000 0134 // INT0 Mode: Falling Edge
; 0000 0135 // INT1: Off
; 0000 0136 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0137 // Interrupt on any change on pins PCINT8-14: Off
; 0000 0138 // Interrupt on any change on pins PCINT16-23: Off
; 0000 0139 EICRA=0x02;
	LDI  R30,LOW(2)
	STS  105,R30
; 0000 013A EIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x1D,R30
; 0000 013B EIFR=0x01;
	OUT  0x1C,R30
; 0000 013C PCICR=0x00;
	LDI  R30,LOW(0)
	STS  104,R30
; 0000 013D 
; 0000 013E // Timer/Counter 0 Interrupt(s) initialization
; 0000 013F TIMSK0=0x00;
	STS  110,R30
; 0000 0140 // Timer/Counter 1 Interrupt(s) initialization
; 0000 0141 TIMSK1=0x00;
	STS  111,R30
; 0000 0142 // Timer/Counter 2 Interrupt(s) initialization
; 0000 0143 TIMSK2=0x00;
	STS  112,R30
; 0000 0144 
; 0000 0145 // USART initialization
; 0000 0146 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 0147 // USART Receiver: On
; 0000 0148 // USART Transmitter: On
; 0000 0149 // USART0 Mode: Asynchronous
; 0000 014A // USART Baud Rate: 57600
; 0000 014B UCSR0A=0x00;
	STS  192,R30
; 0000 014C UCSR0B=0x98;
	LDI  R30,LOW(152)
	STS  193,R30
; 0000 014D UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  194,R30
; 0000 014E UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  197,R30
; 0000 014F UBRR0L=0x06;  //115200--0x06,9600--0x54
	LDI  R30,LOW(6)
	STS  196,R30
; 0000 0150 
; 0000 0151 // Analog Comparator initialization
; 0000 0152 // Analog Comparator: Off
; 0000 0153 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0154 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 0155 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 0156 
; 0000 0157 // ADC initialization
; 0000 0158 // ADC Clock frequency: 156,250 kHz
; 0000 0159 // ADC Voltage Reference: Int., cap. on AREF
; 0000 015A // ADC Auto Trigger Source: Free Running
; 0000 015B // Only the 8 most significant bits of
; 0000 015C // the AD conversion result are used
; 0000 015D // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
; 0000 015E // ADC4: On, ADC5: On
; 0000 015F DIDR0=0x00;
	STS  126,R30
; 0000 0160 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(96)
	STS  124,R30
; 0000 0161 ADCSRA=0xA6;
	LDI  R30,LOW(166)
	STS  122,R30
; 0000 0162 ADCSRB&=0xF8;
	LDS  R30,123
	ANDI R30,LOW(0xF8)
	STS  123,R30
; 0000 0163 
; 0000 0164 // Watchdog Timer initialization
; 0000 0165 // Watchdog Timer Prescaler: OSC/256k
; 0000 0166 // Watchdog Timer interrupt: Off
; 0000 0167 #pragma optsize-
; 0000 0168 #asm("wdr")
	wdr
; 0000 0169 WDTCSR=0x39;
	LDI  R30,LOW(57)
	STS  96,R30
; 0000 016A WDTCSR=0x29;
	LDI  R30,LOW(41)
	STS  96,R30
; 0000 016B #ifdef _OPTIMIZE_SIZE_
; 0000 016C #pragma optsize+
; 0000 016D #endif
; 0000 016E 
; 0000 016F // Global enable interrupts
; 0000 0170 #asm("sei")
	sei
; 0000 0171 PORTC.5=1;delay_ms(200);PORTC.5=0;
	SBI  0x8,5
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0xA
	CBI  0x8,5
; 0000 0172 // FRM12
; 0000 0173 RF12_INIT();
	RCALL _RF12_INIT
; 0000 0174           RF12_tx_on();
	RCALL SUBOPT_0xB
; 0000 0175           delay_ms(5);
; 0000 0176           rtx_pack (0x20);
	RCALL SUBOPT_0xC
; 0000 0177           RF12_rx_on();
; 0000 0178 
; 0000 0179 while (1)
_0x20:
; 0000 017A       {
; 0000 017B           w0=0;w1=0;crc_in=0;
	CLR  R12
	CLR  R11
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xD
; 0000 017C lb1:       while (!(data_rf==0x2D)) {rfxx_flag=1;};
_0x23:
_0x24:
	LDI  R30,LOW(45)
	CP   R30,R5
	BREQ _0x26
	RCALL SUBOPT_0xE
	RJMP _0x24
_0x26:
; 0000 017D            while (!(data_rf==0xD4)) {rfxx_flag=1;};
_0x27:
	LDI  R30,LOW(212)
	CP   R30,R5
	BREQ _0x29
	RCALL SUBOPT_0xE
	RJMP _0x27
_0x29:
; 0000 017E            while (!(data_rf==0x20)) {rfxx_flag=1;};
_0x2A:
	LDI  R30,LOW(32)
	CP   R30,R5
	BREQ _0x2C
	RCALL SUBOPT_0xE
	RJMP _0x2A
_0x2C:
; 0000 017F            while (!(data_rf==0x6A)) {rfxx_flag=1;};      //  
_0x2D:
	LDI  R30,LOW(106)
	CP   R30,R5
	BREQ _0x2F
	RCALL SUBOPT_0xE
	RJMP _0x2D
_0x2F:
; 0000 0180 
; 0000 0181           while (rfxx_flag) {};
_0x30:
	TST  R8
	BRNE _0x30
; 0000 0182           inbuff[0]=data_rf,rfxx_flag=1,crc_in=inbuff[0]%0x31;
	STS  _inbuff,R5
	RCALL SUBOPT_0xE
	LDS  R26,_inbuff
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0xD
; 0000 0183           while (rfxx_flag) {};
_0x33:
	TST  R8
	BRNE _0x33
; 0000 0184           inbuff[1]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[1])%0x31;
	__PUTBMRN _inbuff,1,5
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	__GETB1MN _inbuff,1
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0185           while (rfxx_flag) {};
_0x36:
	TST  R8
	BRNE _0x36
; 0000 0186           inbuff[2]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[2])%0x31;
	__PUTBMRN _inbuff,2,5
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	__GETB1MN _inbuff,2
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0187           while (rfxx_flag) {};
_0x39:
	TST  R8
	BRNE _0x39
; 0000 0188           inbuff[3]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[3])%0x31;
	__PUTBMRN _inbuff,3,5
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	__GETB1MN _inbuff,3
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 0189           while (rfxx_flag) {};
_0x3C:
	TST  R8
	BRNE _0x3C
; 0000 018A           inbuff[4]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[4])%0x31;
	__PUTBMRN _inbuff,4,5
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	__GETB1MN _inbuff,4
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 018B           while (rfxx_flag) {};
_0x3F:
	TST  R8
	BRNE _0x3F
; 0000 018C           inbuff[5]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[5])%0x31;
	__PUTBMRN _inbuff,5,5
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	__GETB1MN _inbuff,5
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xD
; 0000 018D           while (rfxx_flag) {};
_0x42:
	TST  R8
	BRNE _0x42
; 0000 018E           inbuff[6]=data_rf,rfxx_flag=1;
	__PUTBMRN _inbuff,6,5
	RCALL SUBOPT_0xE
; 0000 018F 
; 0000 0190           if (!(inbuff[6]==crc_in)) goto lb1;  // 
	__GETB1MN _inbuff,6
	LDS  R26,_crc_in
	CP   R30,R26
	BREQ _0x45
	RJMP _0x23
; 0000 0191           #asm("wdr")
_0x45:
	wdr
; 0000 0192 
; 0000 0193           //  
; 0000 0194 
; 0000 0195           direct=inbuff[1];
	__GETB1MN _inbuff,1
	STS  _direct,R30
; 0000 0196           speed=inbuff[2];
	__GETBRMN 14,_inbuff,2
; 0000 0197           if (direct>=0x10) PORTD.7=0,PORTB.0=1;
	LDS  R26,_direct
	CPI  R26,LOW(0x10)
	BRLO _0x46
	CBI  0xB,7
	SBI  0x5,0
; 0000 0198           else PORTB.0=0,PORTD.7=1;
	RJMP _0x4B
_0x46:
	CBI  0x5,0
	SBI  0xB,7
; 0000 0199           PORTC&=~0x3C;
_0x4B:
	IN   R30,0x8
	ANDI R30,LOW(0xC3)
	OUT  0x8,R30
; 0000 019A           PORTC|=(inbuff[3])<<2;
	IN   R30,0x8
	MOV  R26,R30
	__GETB1MN _inbuff,3
	LSL  R30
	LSL  R30
	OR   R30,R26
	OUT  0x8,R30
; 0000 019B           if (speed>=0x10) PORTC.1=0,PORTD.4=1;
	LDI  R30,LOW(16)
	CP   R14,R30
	BRLO _0x50
	CBI  0x8,1
	SBI  0xB,4
; 0000 019C           else PORTD.4=0,PORTC.1=1;
	RJMP _0x55
_0x50:
	CBI  0xB,4
	SBI  0x8,1
; 0000 019D           OCR0A=((abs(0x10-direct))<<4)+1;OCR0B=((abs(0x10-speed))<<4)+1;
_0x55:
	LDS  R30,_direct
	RCALL SUBOPT_0x10
	OUT  0x27,R30
	MOV  R30,R14
	RCALL SUBOPT_0x10
	OUT  0x28,R30
; 0000 019E           sost=inbuff[0]+1;
	LDS  R30,_inbuff
	SUBI R30,-LOW(1)
	MOV  R13,R30
; 0000 019F 
; 0000 01A0           //   
; 0000 01A1           RF12_tx_on();
	RCALL SUBOPT_0xB
; 0000 01A2           delay_ms(5);
; 0000 01A3           rtx_pack (0x20);
	RCALL SUBOPT_0xC
; 0000 01A4           RF12_rx_on();
; 0000 01A5 
; 0000 01A6      };
	RJMP _0x20
; 0000 01A7 }
_0x5A:
	RJMP _0x5A

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_rx_buffer0:
	.BYTE 0x20
_direct:
	.BYTE 0x1
_inbuff:
	.BYTE 0x7
_crc_in:
	.BYTE 0x1
__seed_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x0:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _RFXX_WRT_CMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _RFXX_WRT_CMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(32999)
	LDI  R31,HIGH(32999)
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	CLR  R27
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5:
	MOV  R17,R30
	MOV  R26,R17
	CLR  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	RCALL __MODW21
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x7:
	RCALL SUBOPT_0x0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(170)
	ST   -Y,R30
	RJMP _RF12_SEND

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	ST   -Y,R30
	RJMP _RF12_SEND

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	RCALL _RF12_tx_on
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RJMP SUBOPT_0xA

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _rtx_pack
	RJMP _RF12_rx_on

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xD:
	STS  _crc_in,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(1)
	MOV  R8,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	LDS  R26,_crc_in
	CLR  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x10:
	RCALL SUBOPT_0x0
	LDI  R26,LOW(16)
	LDI  R27,HIGH(16)
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	RCALL _abs
	SWAP R30
	ANDI R30,0xF0
	SUBI R30,-LOW(1)
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x9C4
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
