
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega16
;Program type             : Application
;Clock frequency          : 13,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _reg=R5
	.DEF _regold=R4
	.DEF _tflag=R7
	.DEF _i=R6
	.DEF _intflag=R9
	.DEF _data=R8
	.DEF _inkey=R11
	.DEF _key=R10
	.DEF _keyold=R13
	.DEF _ikey=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  _ext_int0_isr
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  _usart_rx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_FontLookup:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x2F
	.DB  0x0,0x0,0x0,0x7,0x0,0x7,0x0,0x14
	.DB  0x7F,0x14,0x7F,0x14,0x24,0x2A,0x7F,0x2A
	.DB  0x12,0xC4,0xC8,0x10,0x26,0x46,0x36,0x49
	.DB  0x55,0x22,0x50,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x1C,0x22,0x41,0x0,0x0,0x41,0x22
	.DB  0x1C,0x0,0x14,0x8,0x3E,0x8,0x14,0x8
	.DB  0x8,0x3E,0x8,0x8,0x0,0x0,0x50,0x30
	.DB  0x0,0x10,0x10,0x10,0x10,0x10,0x0,0x60
	.DB  0x60,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x3E,0x51,0x49,0x45,0x3E,0x0,0x42,0x7F
	.DB  0x40,0x0,0x42,0x61,0x51,0x49,0x46,0x21
	.DB  0x41,0x45,0x4B,0x31,0x18,0x14,0x12,0x7F
	.DB  0x10,0x27,0x45,0x45,0x45,0x39,0x3C,0x4A
	.DB  0x49,0x49,0x30,0x1,0x71,0x9,0x5,0x3
	.DB  0x36,0x49,0x49,0x49,0x36,0x6,0x49,0x49
	.DB  0x29,0x1E,0x0,0x36,0x36,0x0,0x0,0x0
	.DB  0x56,0x36,0x0,0x0,0x8,0x14,0x22,0x41
	.DB  0x0,0x14,0x14,0x14,0x14,0x14,0x0,0x41
	.DB  0x22,0x14,0x8,0x2,0x1,0x51,0x9,0x6
	.DB  0x32,0x49,0x59,0x51,0x3E,0x7E,0x11,0x11
	.DB  0x11,0x7E,0x7F,0x49,0x49,0x49,0x36,0x3E
	.DB  0x41,0x41,0x41,0x22,0x7F,0x41,0x41,0x22
	.DB  0x1C,0x7F,0x49,0x49,0x49,0x41,0x7F,0x9
	.DB  0x9,0x9,0x1,0x3E,0x41,0x49,0x49,0x7A
	.DB  0x7F,0x8,0x8,0x8,0x7F,0x0,0x41,0x7F
	.DB  0x41,0x0,0x20,0x40,0x41,0x3F,0x1,0x7F
	.DB  0x8,0x14,0x22,0x41,0x7F,0x40,0x40,0x40
	.DB  0x40,0x7F,0x2,0xC,0x2,0x7F,0x7F,0x4
	.DB  0x8,0x10,0x7F,0x3E,0x41,0x41,0x41,0x3E
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x51
	.DB  0x21,0x5E,0x7F,0x9,0x19,0x29,0x46,0x46
	.DB  0x49,0x49,0x49,0x31,0x1,0x1,0x7F,0x1
	.DB  0x1,0x3F,0x40,0x40,0x40,0x3F,0x1F,0x20
	.DB  0x40,0x20,0x1F,0x3F,0x40,0x38,0x40,0x3F
	.DB  0x63,0x14,0x8,0x14,0x63,0x7,0x8,0x70
	.DB  0x8,0x7,0x61,0x51,0x49,0x45,0x43,0x0
	.DB  0x7F,0x41,0x41,0x0,0x55,0x2A,0x55,0x2A
	.DB  0x55,0x0,0x41,0x41,0x7F,0x0,0x4,0x2
	.DB  0x1,0x2,0x4,0x40,0x40,0x40,0x40,0x40
	.DB  0x0,0x1,0x2,0x4,0x0,0x20,0x54,0x54
	.DB  0x54,0x78,0x7F,0x48,0x44,0x44,0x38,0x38
	.DB  0x44,0x44,0x44,0x20,0x38,0x44,0x44,0x48
	.DB  0x7F,0x38,0x54,0x54,0x54,0x18,0x8,0x7E
	.DB  0x9,0x1,0x2,0xC,0x52,0x52,0x52,0x3E
	.DB  0x7F,0x8,0x4,0x4,0x78,0x0,0x44,0x7D
	.DB  0x40,0x0,0x20,0x40,0x44,0x3D,0x0,0x7F
	.DB  0x10,0x28,0x44,0x0,0x0,0x41,0x7F,0x40
	.DB  0x0,0x7C,0x4,0x18,0x4,0x78,0x7C,0x8
	.DB  0x4,0x4,0x78,0x38,0x44,0x44,0x44,0x38
	.DB  0x7C,0x14,0x14,0x14,0x8,0x8,0x14,0x14
	.DB  0x18,0x7C,0x7C,0x8,0x4,0x4,0x8,0x48
	.DB  0x54,0x54,0x54,0x20,0x4,0x3F,0x44,0x40
	.DB  0x20,0x3C,0x40,0x40,0x20,0x7C,0x1C,0x20
	.DB  0x40,0x20,0x1C,0x3C,0x40,0x30,0x40,0x3C
	.DB  0x44,0x28,0x10,0x28,0x44,0xC,0x50,0x50
	.DB  0x50,0x3C,0x44,0x64,0x54,0x4C,0x44,0x0
	.DB  0x8,0x36,0x41,0x0,0x0,0x0,0x7F,0x0
	.DB  0x0,0x0,0x41,0x36,0x8,0x0,0x4,0x2
	.DB  0x4,0x8,0x4,0x7E,0x7E,0x0,0x0,0x0
	.DB  0x7E,0x7E,0x0,0x7E,0x7E,0x44,0x44,0x7C
	.DB  0x10,0x10,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x36,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x3E,0x49,0x49,0x49,0x22,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x44,0x45,0x7C,0x45,0x44
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x41,0x7F,0x41,0x0,0x0
	.DB  0x44,0x7D,0x40,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x38,0x54,0x44,0x28,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x4A,0x48,0x7A,0x40,0x40
	.DB  0x7E,0x11,0x11,0x11,0x7E,0x7F,0x49,0x49
	.DB  0x49,0x31,0x7F,0x49,0x49,0x49,0x36,0x7F
	.DB  0x1,0x1,0x1,0x3,0x60,0x3E,0x21,0x21
	.DB  0x7F,0x7F,0x49,0x49,0x49,0x41,0x63,0x14
	.DB  0x7F,0x14,0x63,0x22,0x49,0x49,0x49,0x36
	.DB  0x7F,0x10,0x8,0x4,0x7F,0x7F,0x10,0x9
	.DB  0x4,0x7F,0x7F,0x8,0x14,0x22,0x41,0x7C
	.DB  0x2,0x1,0x1,0x7F,0x7F,0x2,0xC,0x2
	.DB  0x7F,0x7F,0x8,0x8,0x8,0x7F,0x3E,0x41
	.DB  0x41,0x41,0x3E,0x7F,0x1,0x1,0x1,0x7F
	.DB  0x7F,0x9,0x9,0x9,0x6,0x3E,0x41,0x41
	.DB  0x41,0x22,0x1,0x1,0x7F,0x1,0x1,0x7
	.DB  0x48,0x48,0x48,0x3F,0x1C,0x22,0x7F,0x22
	.DB  0x1C,0x63,0x14,0x8,0x14,0x63,0x3F,0x20
	.DB  0x20,0x3F,0x60,0x7,0x8,0x8,0x8,0x7F
	.DB  0x7F,0x40,0x7F,0x40,0x7F,0x3F,0x20,0x3F
	.DB  0x20,0x7F,0x1,0x7F,0x48,0x48,0x30,0x7F
	.DB  0x48,0x48,0x30,0x7F,0x7F,0x48,0x48,0x48
	.DB  0x30,0x22,0x49,0x49,0x49,0x3E,0x7F,0x8
	.DB  0x3E,0x41,0x3E,0x46,0x29,0x19,0x9,0x7F
	.DB  0x20,0x54,0x54,0x54,0x78,0x78,0x54,0x54
	.DB  0x54,0x20,0x7C,0x54,0x54,0x54,0x28,0x7C
	.DB  0x4,0x4,0x4,0x0,0x60,0x38,0x24,0x38
	.DB  0x60,0x38,0x54,0x54,0x54,0x18,0x6C,0x10
	.DB  0x7C,0x10,0x6C,0x28,0x44,0x54,0x54,0x28
	.DB  0x3C,0x40,0x40,0x20,0x7C,0x3C,0x40,0x42
	.DB  0x20,0x7C,0x7C,0x10,0x10,0x28,0x44,0x60
	.DB  0x10,0x8,0x4,0x7C,0x7C,0x8,0x10,0x8
	.DB  0x7C,0x7C,0x10,0x10,0x10,0x7C,0x38,0x44
	.DB  0x44,0x44,0x38,0x7C,0x4,0x4,0x4,0x7C
	.DB  0x7C,0x14,0x14,0x14,0x8,0x38,0x44,0x44
	.DB  0x44,0x20,0x4,0x4,0x7C,0x4,0x4,0xC
	.DB  0x50,0x50,0x50,0x3C,0x18,0x24,0x7C,0x24
	.DB  0x18,0x44,0x28,0x10,0x28,0x44,0x3C,0x20
	.DB  0x20,0x3C,0x60,0xC,0x10,0x10,0x10,0x7C
	.DB  0x7C,0x40,0x7C,0x40,0x7C,0x3C,0x20,0x3C
	.DB  0x20,0x7C,0x4,0x7C,0x48,0x48,0x30,0x7C
	.DB  0x48,0x30,0x0,0x7C,0x7C,0x48,0x48,0x48
	.DB  0x30,0x28,0x44,0x54,0x54,0x38,0x7C,0x10
	.DB  0x38,0x44,0x38,0x58,0x24,0x24,0x24,0x7C
_tbl10_G102:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G102:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x0000

_0x3:
	.DB  0x20,0x20,0x20
_0x4:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x0,0xC7,0xC0,0xD0,0xDF,0xC4,0xCA
	.DB  0xC0,0x20,0x20,0x0,0xD1,0xC8,0xC3,0xCD
	.DB  0xC0,0xCB,0x20,0x20,0x20,0x0,0xCA,0xCE
	.DB  0xD0,0xC0,0xC1,0xCB,0xDC,0x20,0x20,0x0
	.DB  0xCD,0xC0,0xD1,0xD2,0xD0,0x20,0x31,0x20
	.DB  0xD1,0x0,0xCD,0xC0,0xD1,0xD2,0xD0,0x20
	.DB  0x32,0x20,0xD1,0x0,0xCD,0xC0,0xD1,0xD2
	.DB  0xD0,0x20,0x33,0x20,0xD1,0x0,0x43,0x4F
	.DB  0x4D,0x3C,0x3E,0x52,0x46,0x20,0x20,0x0
	.DB  0xD3,0xD1,0xD2,0x20,0xD7,0xC0,0xD1,0xCE
	.DB  0xC2,0x0,0xC0,0xCA,0xD1,0xC5,0xCB,0xC5
	.DB  0xD0,0xCE,0xCC
_0x5:
	.DB  0xC
_0x6:
	.DB  0x1
_0x7:
	.DB  0x1
_0x8:
	.DB  0x1
_0x9:
	.DB  0x1
_0xA:
	.DB  0x10
_0xB:
	.DB  0x10
_0x100:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0
_0x200005F:
	.DB  0x1
_0x2000000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x03
	.DW  _stroka
	.DW  _0x3*2

	.DW  0x63
	.DW  _tst
	.DW  _0x4*2

	.DW  0x01
	.DW  _tkey
	.DW  _0x5*2

	.DW  0x01
	.DW  _slen
	.DW  _0x6*2

	.DW  0x01
	.DW  _rfxx_flag
	.DW  _0x8*2

	.DW  0x01
	.DW  _rfto_flag
	.DW  _0x9*2

	.DW  0x01
	.DW  _xas
	.DW  _0xA*2

	.DW  0x01
	.DW  _yas
	.DW  _0xB*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x100*2

	.DW  0x01
	.DW  __seed_G100
	.DW  _0x200005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 26.08.2012
;Author  : NeVaDa
;Company :
;Comments:
;
;
;Chip type               : ATmega16
;Program type            : Application
;AVR Core Clock frequency: 13,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <stdlib.h>
;#include <delay.h>
;#include "GPM388CO.h"
;#include <sleep.h>
;#include <io.h>
;
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=1
   .equ __scl_bit=0
; 0000 0024 #endasm
;#include <i2c.h>
;
;typedef struct{
;    unsigned char tick;
;    unsigned char second;
;    unsigned char minute;
;    unsigned char hour;
;}time;
;
;time t;
;
;char reg=0,regold=0,tflag,i,intflag=0;
;char stroka[4]="   ",sms[3];

	.DSEG
;const char tst[10][10]={"         ","  ","   ","  "," 1 ",
;                              " 2 "," 3 ","COM<>RF  "," ",""};
;
;//  
;unsigned char data,inkey,key,keyold=0,ikey=0,tkey=12,slen=1,ack=1;
;unsigned char data_rf,rfxx_flag=1,w0,w1,inbuff[7],crc_in,rfto_flag=1;
;
;#define BUF_SIZE    32  //     !
;#define BUF_MASK    (BUF_SIZE-1)
;
;volatile unsigned char idxIN=0, idxOUT=0;
;volatile unsigned char buffer [BUF_SIZE];
;
;// 
;char xas=16,yas=16,xin,yin,rfm=0;
;unsigned int temp,status_rf;
;
;#define keyred 0x20
;#define keyu 0x02
;#define keyd 0x04
;#define keyr 0x01
;#define keyl 0x08
;#define keyc 0x06
;#define keyg 0x09
;#define keyrs 0x25
;#define keyls 0x2c
;#define keys 0x10
;#define keyforv 0x12
;#define keyback 0x14
;#define keyleft 0x18
;#define keyright 0x11
;#define keylset 0x0c
;#define keyrset 0x05
;#define keylight 0x3c
;#define keyhorn 0x35
;#define keydrive 0x30
;#define keyset1 0x28
;#define keyset2 0x22
;#define keyset3 0x28
;#define keycom 0x24
;#define keysettime 0x41
;#define keyacs 0x29
;#define keyout 0x44
;
;#ifndef RXB8
;#define RXB8 1
;#endif
;
;#ifndef TXB8
;#define TXB8 0
;#endif
;
;#ifndef UPE
;#define UPE 2
;#endif
;
;#ifndef DOR
;#define DOR 3
;#endif
;
;#ifndef FE
;#define FE 4
;#endif
;
;#ifndef UDRE
;#define UDRE 5
;#endif
;
;#ifndef RXC
;#define RXC 7
;#endif
;
;#define FRAMING_ERROR (1<<FE)
;#define PARITY_ERROR (1<<UPE)
;#define DATA_OVERRUN (1<<DOR)
;#define DATA_REGISTER_EMPTY (1<<UDRE)
;#define RX_COMPLETE (1<<RXC)
;
;// USART Receiver buffer
;#define RX_BUFFER_SIZE 32
;char rx_buffer[RX_BUFFER_SIZE];
;
;#if RX_BUFFER_SIZE<256
;unsigned char rx_wr_index,rx_rd_index,rx_counter;
;#else
;unsigned int rx_wr_index,rx_rd_index,rx_counter;
;#endif
;
;// This flag is set on USART Receiver buffer overflow
;bit rx_buffer_overflow;
;
;// USART Receiver interrupt service routine
;interrupt [USART_RXC] void usart_rx_isr(void)
; 0000 008F {

	.CSEG
_usart_rx_isr:
	ST   -Y,R26
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0090 char status,data;
; 0000 0091 status=UCSRA;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
; 0000 0092 data=UDR;
	IN   R16,12
; 0000 0093 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0xC
; 0000 0094    {
; 0000 0095    rx_buffer[rx_wr_index]=data;
	LDS  R30,_rx_wr_index
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	ST   Z,R16
; 0000 0096    if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	LDS  R26,_rx_wr_index
	SUBI R26,-LOW(1)
	STS  _rx_wr_index,R26
	CPI  R26,LOW(0x20)
	BRNE _0xD
	LDI  R30,LOW(0)
	STS  _rx_wr_index,R30
; 0000 0097    if (++rx_counter == RX_BUFFER_SIZE)
_0xD:
	LDS  R26,_rx_counter
	SUBI R26,-LOW(1)
	STS  _rx_counter,R26
	CPI  R26,LOW(0x20)
	BRNE _0xE
; 0000 0098       {
; 0000 0099       rx_counter=0;
	LDI  R30,LOW(0)
	STS  _rx_counter,R30
; 0000 009A       rx_buffer_overflow=1;
	SET
	BLD  R2,0
; 0000 009B       };
_0xE:
; 0000 009C    };
_0xC:
; 0000 009D }
	LD   R16,Y+
	LD   R17,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;#ifndef _DEBUG_TERMINAL_IO_
;// Get a character from the USART Receiver buffer
;#define _ALTERNATE_GETCHAR_
;#pragma used+
;char getchar(void)
; 0000 00A4 {
; 0000 00A5 char data;
; 0000 00A6 while (rx_counter==0);
;	data -> R17
; 0000 00A7 data=rx_buffer[rx_rd_index];
; 0000 00A8 if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
; 0000 00A9 #asm("cli")
; 0000 00AA --rx_counter;
; 0000 00AB #asm("sei")
; 0000 00AC return data;
; 0000 00AD }
;#pragma used-
;#endif
;
;// Standard Input/Output functions
;#include <stdio.h>
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 00B6 {
_timer2_ovf_isr:
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 00B7 
; 0000 00B8    if (++t.tick==4)
	LDS  R26,_t
	SUBI R26,-LOW(1)
	STS  _t,R26
	CPI  R26,LOW(0x4)
	BRNE _0x13
; 0000 00B9     {
; 0000 00BA       t.tick=0;tflag=1;
	LDI  R30,LOW(0)
	STS  _t,R30
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 00BB    if (++t.second==60)
	__GETB1MN _t,1
	SUBI R30,-LOW(1)
	__PUTB1MN _t,1
	CPI  R30,LOW(0x3C)
	BRNE _0x14
; 0000 00BC     {
; 0000 00BD         t.second=0;
	LDI  R30,LOW(0)
	__PUTB1MN _t,1
; 0000 00BE          if (++t.minute==60)
	__GETB1MN _t,2
	SUBI R30,-LOW(1)
	__PUTB1MN _t,2
	CPI  R30,LOW(0x3C)
	BRNE _0x15
; 0000 00BF         {
; 0000 00C0             t.minute=0;
	LDI  R30,LOW(0)
	__PUTB1MN _t,2
; 0000 00C1              if (++t.hour==24)
	__GETB1MN _t,3
	SUBI R30,-LOW(1)
	__PUTB1MN _t,3
	CPI  R30,LOW(0x18)
	BRNE _0x16
; 0000 00C2             {
; 0000 00C3                 t.hour=0;
	LDI  R30,LOW(0)
	__PUTB1MN _t,3
; 0000 00C4 
; 0000 00C5             }
; 0000 00C6         }
_0x16:
; 0000 00C7     }
_0x15:
; 0000 00C8   }
_0x14:
; 0000 00C9 
; 0000 00CA }
_0x13:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	RETI
;
;#define ADC_VREF_TYPE 0x60
;
;// Read the 8 most significant bits
;// of the AD conversion result
;unsigned char read_adc(unsigned char adc_input)
; 0000 00D1 {
_read_adc:
; 0000 00D2 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,LOW(0x60)
	OUT  0x7,R30
; 0000 00D3 // Delay needed for the stabilization of the ADC input voltage
; 0000 00D4 delay_us(10);
	__DELAY_USB 43
; 0000 00D5 // Start the AD conversion
; 0000 00D6 ADCSRA|=0x40;
	SBI  0x6,6
; 0000 00D7 // Wait for the AD conversion to complete
; 0000 00D8 while ((ADCSRA & 0x10)==0);
_0x17:
	SBIS 0x6,4
	RJMP _0x17
; 0000 00D9 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 00DA return ADCH;
	IN   R30,0x5
	RJMP _0x20C0002
; 0000 00DB }
;
;/// RFM12 
;
;unsigned int RFXX_WRT_CMD(unsigned int aCmd) // 
; 0000 00E0 {
_RFXX_WRT_CMD:
; 0000 00E1 unsigned char i;
; 0000 00E2 unsigned int temp=0;
; 0000 00E3 PORTB.7=0;
	CALL __SAVELOCR4
;	aCmd -> Y+4
;	i -> R17
;	temp -> R18,R19
	__GETWRN 18,19,0
	CBI  0x18,7
; 0000 00E4 PORTB.4=0;
	CBI  0x18,4
; 0000 00E5 for(i=0;i<16;i++)
	LDI  R17,LOW(0)
_0x1F:
	CPI  R17,16
	BRSH _0x20
; 0000 00E6    {
; 0000 00E7    if(aCmd&0x8000) PORTB.5=1;
	LDD  R30,Y+5
	ANDI R30,LOW(0x80)
	BREQ _0x21
	SBI  0x18,5
; 0000 00E8    else PORTB.5=0;
	RJMP _0x24
_0x21:
	CBI  0x18,5
; 0000 00E9    PORTB.7=1;
_0x24:
	SBI  0x18,7
; 0000 00EA    temp<<=1;
	LSL  R18
	ROL  R19
; 0000 00EB    if(PINB.6) temp|=0x0001;
	SBIC 0x16,6
	ORI  R18,LOW(1)
; 0000 00EC    PORTB.7=0;
	CBI  0x18,7
; 0000 00ED    aCmd<<=1;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LSL  R30
	ROL  R31
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 00EE    }
	SUBI R17,-1
	RJMP _0x1F
_0x20:
; 0000 00EF PORTB.4=1;
	SBI  0x18,4
; 0000 00F0 return(temp);
	MOVW R30,R18
	CALL __LOADLOCR4
	ADIW R28,6
	RET
; 0000 00F1 }
;
;void RF12_INIT(void) //
; 0000 00F4 {
_RF12_INIT:
; 0000 00F5 while (!PIND.2) RFXX_WRT_CMD(0x0000);
_0x2E:
	SBIC 0x10,2
	RJMP _0x30
	CALL SUBOPT_0x0
	RJMP _0x2E
_0x30:
; 0000 00F7 RFXX_WRT_CMD(0x80E7);
	CALL SUBOPT_0x1
; 0000 00F8 RFXX_WRT_CMD(0x8219);//!er,!ebb,!ET,ES,EX,!eb,!ew,DC
	LDI  R30,LOW(33305)
	LDI  R31,HIGH(33305)
	CALL SUBOPT_0x2
; 0000 00F9 RFXX_WRT_CMD(0xA640);//=868MHz
	LDI  R30,LOW(42560)
	LDI  R31,HIGH(42560)
	CALL SUBOPT_0x2
; 0000 00FA RFXX_WRT_CMD(0xC647);//06->57.6kbps 47->4.8kbps
	LDI  R30,LOW(50759)
	LDI  R31,HIGH(50759)
	CALL SUBOPT_0x2
; 0000 00FB RFXX_WRT_CMD(0x94C0);//VDI,FAST,67kHz,0dBm,-103dBm
	LDI  R30,LOW(38080)
	LDI  R31,HIGH(38080)
	CALL SUBOPT_0x2
; 0000 00FC RFXX_WRT_CMD(0xC2AC);//AL,!ml,DIG,DQD4
	LDI  R30,LOW(49836)
	LDI  R31,HIGH(49836)
	CALL SUBOPT_0x2
; 0000 00FD RFXX_WRT_CMD(0xCAB0);//FIFO11,SYNC,!ff,DR
	LDI  R30,LOW(51888)
	LDI  R31,HIGH(51888)
	CALL SUBOPT_0x2
; 0000 00FE RFXX_WRT_CMD(0xC4F3);//@PWR,NO RSTRIC,!st,!fi,OE,EN
	LDI  R30,LOW(50419)
	LDI  R31,HIGH(50419)
	CALL SUBOPT_0x2
; 0000 00FF RFXX_WRT_CMD(0x9820);//!mp,45kHz,MAX OUT
	LDI  R30,LOW(38944)
	LDI  R31,HIGH(38944)
	CALL SUBOPT_0x2
; 0000 0100 RFXX_WRT_CMD(0xCC07);
	LDI  R30,LOW(52231)
	LDI  R31,HIGH(52231)
	CALL SUBOPT_0x2
; 0000 0101 RFXX_WRT_CMD(0xE000);//NOT USE
	LDI  R30,LOW(57344)
	LDI  R31,HIGH(57344)
	CALL SUBOPT_0x2
; 0000 0102 RFXX_WRT_CMD(0xC800);//NOT USE
	LDI  R30,LOW(51200)
	LDI  R31,HIGH(51200)
	CALL SUBOPT_0x2
; 0000 0103 RFXX_WRT_CMD(0xC000);//1MHz,2.2V
	LDI  R30,LOW(49152)
	LDI  R31,HIGH(49152)
	RJMP _0x20C0003
; 0000 0104 }
;
;void RF12_SEND(unsigned char aByte)
; 0000 0107 {
_RF12_SEND:
; 0000 0108 while(!(RFXX_WRT_CMD(0x0000)&0x8000));
;	aByte -> Y+0
_0x31:
	CALL SUBOPT_0x0
	ANDI R31,HIGH(0x8000)
	BREQ _0x31
; 0000 0109 RFXX_WRT_CMD(0xB800+aByte);
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-47104)
	SBCI R31,HIGH(-47104)
	CALL SUBOPT_0x2
; 0000 010A }
	RJMP _0x20C0002
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)
; 0000 010D {
_ext_int0_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 010E status_rf=RFXX_WRT_CMD(0x0000);
	CALL SUBOPT_0x0
	STS  _status_rf,R30
	STS  _status_rf+1,R31
; 0000 010F data_rf=(char)((RFXX_WRT_CMD(0xB000))&0x00FF);
	LDI  R30,LOW(45056)
	LDI  R31,HIGH(45056)
	CALL SUBOPT_0x2
	STS  _data_rf,R30
; 0000 0110 rfxx_flag=0;
	LDI  R30,LOW(0)
	STS  _rfxx_flag,R30
; 0000 0111 //buffer[idxIN++]=(char)((RFXX_WRT_CMD(0xB000))&0x00FF);
; 0000 0112 //idxIN &= BUF_MASK;
; 0000 0113 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;void fifo_reset(void)
; 0000 0115   {
_fifo_reset:
; 0000 0116   RFXX_WRT_CMD(0xCAB0);
	LDI  R30,LOW(51888)
	LDI  R31,HIGH(51888)
	CALL SUBOPT_0x2
; 0000 0117   RFXX_WRT_CMD(0xCAB2);
	LDI  R30,LOW(51890)
	LDI  R31,HIGH(51890)
	RJMP _0x20C0003
; 0000 0118   }
;
;void RF12_tx_on(void)
; 0000 011B   {
_RF12_tx_on:
; 0000 011C    RFXX_WRT_CMD(0x80E7);
	CALL SUBOPT_0x1
; 0000 011D    RFXX_WRT_CMD(0x8239);
	LDI  R30,LOW(33337)
	LDI  R31,HIGH(33337)
_0x20C0003:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _RFXX_WRT_CMD
; 0000 011E   }
	RET
;
;void RF12_rx_on(void)
; 0000 0121   {
_RF12_rx_on:
; 0000 0122    RFXX_WRT_CMD(0x80E7);
	CALL SUBOPT_0x1
; 0000 0123    RFXX_WRT_CMD(0x8299);
	LDI  R30,LOW(33433)
	LDI  R31,HIGH(33433)
	CALL SUBOPT_0x2
; 0000 0124    fifo_reset();
	RCALL _fifo_reset
; 0000 0125   }
	RET
;
;unsigned char idxDiff (unsigned char idxIN, unsigned char idxOUT)
; 0000 0128 {
; 0000 0129 return (idxIN - idxOUT)&BUF_MASK;
;	idxIN -> Y+1
;	idxOUT -> Y+0
; 0000 012A }
;
;unsigned char rrx_data (unsigned char idxOUT)
; 0000 012D  {
; 0000 012E  unsigned char value;
; 0000 012F  value = buffer[idxOUT];
;	idxOUT -> Y+1
;	value -> R17
; 0000 0130  idxOUT &= BUF_MASK;
; 0000 0131  return value;
; 0000 0132  }
;
;//Internal
;void set_row_clm(unsigned char row,unsigned char clm)//   
; 0000 0136   {
_set_row_clm:
; 0000 0137   if((row < 8)&(clm < 98))
;	row -> Y+1
;	clm -> Y+0
	LDD  R26,Y+1
	LDI  R30,LOW(8)
	CALL __LTB12U
	MOV  R0,R30
	LD   R26,Y
	LDI  R30,LOW(98)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x34
; 0000 0138    {
; 0000 0139    i2c_start();
	CALL SUBOPT_0x3
; 0000 013A    i2c_write(0x78);i2c_write(0x00);i2c_write(0x28);i2c_write(row + 0x40);i2c_write(clm + 0x80);
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
	LDD  R30,Y+1
	SUBI R30,-LOW(64)
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	SUBI R30,-LOW(128)
	CALL SUBOPT_0x6
; 0000 013B    i2c_stop();
; 0000 013C    }
; 0000 013D   }
_0x34:
	ADIW R28,2
	RET
;void write_column(unsigned char dat_byte)//    
; 0000 013F   {
_write_column:
; 0000 0140    //
; 0000 0141    i2c_start();
;	dat_byte -> Y+0
	CALL SUBOPT_0x3
; 0000 0142    i2c_write(0x78);i2c_write(0x40);i2c_write(dat_byte);
	CALL SUBOPT_0x7
	LD   R30,Y
	CALL SUBOPT_0x6
; 0000 0143    i2c_stop();
; 0000 0144   }
_0x20C0002:
	ADIW R28,1
	RET
;//External
;void clear_lcd(void)//  
; 0000 0147   {
_clear_lcd:
; 0000 0148   int i;
; 0000 0149   i2c_start();
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	CALL SUBOPT_0x3
; 0000 014A   i2c_write(0x78);
; 0000 014B   i2c_write(0x40);
	CALL SUBOPT_0x7
; 0000 014C   for(i = 0; i < 918; i++)
	__GETWRN 16,17,0
_0x36:
	__CPWRN 16,17,918
	BRGE _0x37
; 0000 014D   {
; 0000 014E    i2c_write(0x00);
	CALL SUBOPT_0x4
; 0000 014F   }
	__ADDWRN 16,17,1
	RJMP _0x36
_0x37:
; 0000 0150   i2c_stop();
	CALL _i2c_stop
; 0000 0151   }
	LD   R16,Y+
	LD   R17,Y+
	RET
;void GPM388CO_init(void)//  
; 0000 0153   {
_GPM388CO_init:
; 0000 0154 
; 0000 0155   delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x8
; 0000 0156 
; 0000 0157   i2c_start();
	CALL SUBOPT_0x3
; 0000 0158   i2c_write(0x78);i2c_write(0x00);i2c_write(0x29);i2c_write(0x14);
	CALL SUBOPT_0x4
	CALL SUBOPT_0x9
	LDI  R30,LOW(20)
	ST   -Y,R30
	CALL _i2c_write
; 0000 0159   i2c_write(0x06);i2c_write(0x28);i2c_write(0x11);i2c_write(0x05);
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _i2c_write
	CALL SUBOPT_0x5
	LDI  R30,LOW(17)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _i2c_write
; 0000 015A   i2c_write(0x29);i2c_write(0x9A);i2c_write(0x0C);i2c_write(0x28);
	CALL SUBOPT_0x9
	LDI  R30,LOW(154)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL _i2c_write
	CALL SUBOPT_0x5
; 0000 015B   i2c_write(0x0C);i2c_write(0x40);i2c_write(0x80);
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL _i2c_write
	CALL SUBOPT_0x7
	LDI  R30,LOW(128)
	CALL SUBOPT_0x6
; 0000 015C   i2c_stop();
; 0000 015D 
; 0000 015E   i2c_start();
	CALL SUBOPT_0x3
; 0000 015F   i2c_write(0x78);i2c_write(0x00);
	CALL SUBOPT_0x4
; 0000 0160   i2c_write(0x29);i2c_write(0x9A);
	CALL SUBOPT_0x9
	LDI  R30,LOW(154)
	CALL SUBOPT_0x6
; 0000 0161   i2c_stop();
; 0000 0162    clear_lcd();
	RCALL _clear_lcd
; 0000 0163   }
	RET
;
;
;void LcdPutLine(unsigned char *data, unsigned char line, unsigned char clm, unsigned char mode)
; 0000 0167 //    
; 0000 0168   {
_LcdPutLine:
; 0000 0169    unsigned int i;
; 0000 016A    unsigned char ch;
; 0000 016B    unsigned char chr_coutnt = 0;
; 0000 016C 
; 0000 016D    set_row_clm(line,clm);
	CALL __SAVELOCR4
;	*data -> Y+7
;	line -> Y+6
;	clm -> Y+5
;	mode -> Y+4
;	i -> R16,R17
;	ch -> R19
;	chr_coutnt -> R18
	LDI  R18,0
	CALL SUBOPT_0xA
; 0000 016E 
; 0000 016F    i2c_start();
; 0000 0170    i2c_write(0x78);i2c_write(0x40);
	CALL SUBOPT_0x7
; 0000 0171 
; 0000 0172    	while (*data)
_0x38:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LD   R30,X
	CPI  R30,0
	BRNE PC+3
	JMP _0x3A
; 0000 0173 	{
; 0000 0174         if(chr_coutnt > 15)
	CPI  R18,16
	BRLO _0x3B
; 0000 0175          {
; 0000 0176           chr_coutnt = 0;
	LDI  R18,LOW(0)
; 0000 0177           line++;clm = 0;
	LDD  R30,Y+6
	SUBI R30,-LOW(1)
	STD  Y+6,R30
	LDI  R30,LOW(0)
	STD  Y+5,R30
; 0000 0178           set_row_clm(line,clm);
	CALL SUBOPT_0xA
; 0000 0179           i2c_start();
; 0000 017A           i2c_write(0x78);i2c_write(0x40);
	CALL SUBOPT_0x7
; 0000 017B          }
; 0000 017C 	   	for(i=0; i<5; i++)
_0x3B:
	__GETWRN 16,17,0
_0x3D:
	__CPWRN 16,17,5
	BRSH _0x3E
; 0000 017D 		{
; 0000 017E 	     ch = FontLookup[*data - 32][i] << 1;
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	LD   R30,X
	LDI  R31,0
	SBIW R30,32
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12U
	SUBI R30,LOW(-_FontLookup*2)
	SBCI R31,HIGH(-_FontLookup*2)
	ADD  R30,R16
	ADC  R31,R17
	LPM  R30,Z
	LSL  R30
	MOV  R19,R30
; 0000 017F 	     	if(mode)
	LDD  R30,Y+4
	CPI  R30,0
	BREQ _0x3F
; 0000 0180 			{
; 0000 0181 			i2c_write(~ch);
	MOV  R30,R19
	COM  R30
	ST   -Y,R30
	RJMP _0xFC
; 0000 0182 			}
; 0000 0183 	        else
_0x3F:
; 0000 0184 			{
; 0000 0185 			i2c_write(ch);
	ST   -Y,R19
_0xFC:
	CALL _i2c_write
; 0000 0186 			}
; 0000 0187 	     if(i == 4)
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x41
; 0000 0188 		 {
; 0000 0189 		  if(mode)
	LDD  R30,Y+4
	CPI  R30,0
	BREQ _0x42
; 0000 018A 		   {
; 0000 018B 		    i2c_write(0xff);
	LDI  R30,LOW(255)
	RJMP _0xFD
; 0000 018C 		    }
; 0000 018D 		   else
_0x42:
; 0000 018E 		   {
; 0000 018F 		    i2c_write(0x00);
	LDI  R30,LOW(0)
_0xFD:
	ST   -Y,R30
	CALL _i2c_write
; 0000 0190 		   }
; 0000 0191 		}
; 0000 0192       }
_0x41:
	__ADDWRN 16,17,1
	RJMP _0x3D
_0x3E:
; 0000 0193       data++;
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	STD  Y+7,R30
	STD  Y+7+1,R31
; 0000 0194       chr_coutnt++;
	SUBI R18,-1
; 0000 0195       }
	RJMP _0x38
_0x3A:
; 0000 0196   }
	CALL __LOADLOCR4
	ADIW R28,9
	RET
;void LcdBarLine(unsigned char line, unsigned char row, unsigned char clm)
; 0000 0198  // 
; 0000 0199  {
_LcdBarLine:
; 0000 019A       set_row_clm(row,clm);
;	line -> Y+2
;	row -> Y+1
;	clm -> Y+0
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _set_row_clm
; 0000 019B       for (i=0;i<line;i++) write_column(0xFF);
	CLR  R6
_0x45:
	LDD  R30,Y+2
	CP   R6,R30
	BRSH _0x46
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _write_column
	INC  R6
	RJMP _0x45
_0x46:
; 0000 019C for (i=line;i<66;i++) write_column(0x00);
	LDD  R6,Y+2
_0x48:
	LDI  R30,LOW(66)
	CP   R6,R30
	BRSH _0x49
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x48
_0x49:
; 0000 019D }
	ADIW R28,3
	RET
;
;void probel (void) {
; 0000 019F void probel (void) {
_probel:
; 0000 01A0   for (i=0;i<12;i++) write_column(0x00);
	CLR  R6
_0x4B:
	LDI  R30,LOW(12)
	CP   R6,R30
	BRSH _0x4C
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x4B
_0x4C:
; 0000 01A1 }
	RET
;
;    //  
;unsigned char keypress (void)
; 0000 01A5   {
_keypress:
; 0000 01A6   char skey;
; 0000 01A7   key=(~PINC)&0x3f;
	ST   -Y,R17
;	skey -> R17
	IN   R30,0x13
	COM  R30
	ANDI R30,LOW(0x3F)
	MOV  R10,R30
; 0000 01A8   if (key) ikey++,delay_ms(1);
	TST  R10
	BREQ _0x4D
	INC  R12
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0x8
; 0000 01A9 
; 0000 01AA   if ((key!=keyold)&&(keyold==0))
_0x4D:
	CP   R13,R10
	BREQ _0x4F
	LDI  R30,LOW(0)
	CP   R30,R13
	BREQ _0x50
_0x4F:
	RJMP _0x4E
_0x50:
; 0000 01AB     {
; 0000 01AC       PORTA.4=1,PORTD.6=1,delay_ms(50),PORTA.4=0,PORTD.6=0;
	CALL SUBOPT_0xC
	CBI  0x1B,4
	CBI  0x12,6
; 0000 01AD     };
_0x4E:
; 0000 01AE 
; 0000 01AF   if (key!=keyold)
	CP   R13,R10
	BREQ _0x59
; 0000 01B0     {
; 0000 01B1     skey=keyold;
	MOV  R17,R13
; 0000 01B2     keyold=key;
	MOV  R13,R10
; 0000 01B3     if (key) ikey=0;
	TST  R10
	BREQ _0x5A
	CLR  R12
; 0000 01B4     }
_0x5A:
; 0000 01B5 
; 0000 01B6   if (ikey&&(ikey<tkey)&&(key==0))
_0x59:
	TST  R12
	BREQ _0x5C
	LDS  R30,_tkey
	CP   R12,R30
	BRSH _0x5C
	LDI  R30,LOW(0)
	CP   R30,R10
	BREQ _0x5D
_0x5C:
	RJMP _0x5B
_0x5D:
; 0000 01B7       {
; 0000 01B8       ikey=0;
	CLR  R12
; 0000 01B9       keyold=0;
	CLR  R13
; 0000 01BA       return skey;
	MOV  R30,R17
	RJMP _0x20C0001
; 0000 01BB       }
; 0000 01BC 
; 0000 01BD   if ((ikey==tkey)&&(key))
_0x5B:
	LDS  R30,_tkey
	CP   R30,R12
	BRNE _0x5F
	TST  R10
	BRNE _0x60
_0x5F:
	RJMP _0x5E
_0x60:
; 0000 01BE         {
; 0000 01BF            PORTA.4=1,PORTD.6=1,delay_ms(50),PORTA.4=0;
	CALL SUBOPT_0xC
	CBI  0x1B,4
; 0000 01C0            delay_ms(50);PORTD.6=0;
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CALL SUBOPT_0x8
	CBI  0x12,6
; 0000 01C1            key=key+0x40;
	LDI  R30,LOW(64)
	ADD  R10,R30
; 0000 01C2            ikey=0;
	CLR  R12
; 0000 01C3            //keyold=0;
; 0000 01C4          return key;
	MOV  R30,R10
	RJMP _0x20C0001
; 0000 01C5         };
_0x5E:
; 0000 01C6 
; 0000 01C7   if (ikey) return 0x3f;
	TST  R12
	BREQ _0x69
	LDI  R30,LOW(63)
	RJMP _0x20C0001
; 0000 01C8   return 0;
_0x69:
	LDI  R30,LOW(0)
_0x20C0001:
	LD   R17,Y+
	RET
; 0000 01C9   }
;
;  //  
;void showtime (void)
; 0000 01CD   {
_showtime:
; 0000 01CE    if (tflag)
	TST  R7
	BREQ _0x6A
; 0000 01CF         {
; 0000 01D0         itoa(t.hour,stroka);
	__GETB1MN _t,3
	CALL SUBOPT_0xD
; 0000 01D1         LcdPutLine(stroka,0,24,0);
	LDI  R30,LOW(24)
	CALL SUBOPT_0xE
; 0000 01D2         for (i=0;i<6;i++) write_column(0x00);
_0x6C:
	LDI  R30,LOW(6)
	CP   R6,R30
	BRSH _0x6D
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x6C
_0x6D:
; 0000 01D3 itoa( t.minute,stroka);
	__GETB1MN _t,2
	CALL SUBOPT_0xD
; 0000 01D4         LcdPutLine(stroka,0,42,0);
	LDI  R30,LOW(42)
	CALL SUBOPT_0xE
; 0000 01D5         for (i=0;i<6;i++) write_column(0x00);
_0x6F:
	LDI  R30,LOW(6)
	CP   R6,R30
	BRSH _0x70
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x6F
_0x70:
; 0000 01D6 itoa(t.second,stroka);
	__GETB1MN _t,1
	CALL SUBOPT_0xD
; 0000 01D7         LcdPutLine(stroka,0,60,0);
	LDI  R30,LOW(60)
	CALL SUBOPT_0xE
; 0000 01D8         for (i=0;i<6;i++) write_column(0x00);
_0x72:
	LDI  R30,LOW(6)
	CP   R6,R30
	BRSH _0x73
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x72
_0x73:
; 0000 01D9 itoa(reg,stroka);
	MOV  R30,R5
	CALL SUBOPT_0xD
; 0000 01DA         LcdPutLine(stroka,0,78,0);
	LDI  R30,LOW(78)
	CALL SUBOPT_0xE
; 0000 01DB         for (i=0;i<6;i++) write_column(0x00);
_0x75:
	LDI  R30,LOW(6)
	CP   R6,R30
	BRSH _0x76
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x75
_0x76:
; 0000 01DC };
_0x6A:
; 0000 01DD         tflag=0;
	CLR  R7
; 0000 01DE 
; 0000 01DF   }
	RET
;void rtx_pack (unsigned char ack)
; 0000 01E1   {
_rtx_pack:
; 0000 01E2    unsigned char crc,ar1,ar2;
; 0000 01E3    ar1=0xAA;
	CALL __SAVELOCR4
;	ack -> Y+4
;	crc -> R17
;	ar1 -> R16
;	ar2 -> R19
	LDI  R16,LOW(170)
; 0000 01E4    ar2=(~PINC)&0x0f;;
	IN   R30,0x13
	COM  R30
	ANDI R30,LOW(0xF)
	MOV  R19,R30
; 0000 01E5    //ar3=read_adc(6);
; 0000 01E6 
; 0000 01E7    crc=0x80%0x31;
	LDI  R17,LOW(30)
; 0000 01E8    crc=(crc+xas)%0x31;
	MOV  R26,R17
	CLR  R27
	LDS  R30,_xas
	CALL SUBOPT_0xF
; 0000 01E9    crc=(crc+yas)%0x31;
	LDS  R30,_yas
	CALL SUBOPT_0xF
; 0000 01EA    crc=(crc+ar2)%0x31;
	CLR  R30
	ADD  R26,R19
	ADC  R27,R30
	CALL SUBOPT_0x10
; 0000 01EB    crc=(crc+ar1)%0x31;
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	CALL SUBOPT_0x10
; 0000 01EC    crc=(crc+ack)%0x31;
	LDD  R30,Y+4
	CALL SUBOPT_0x11
	MOV  R17,R30
; 0000 01ED   RF12_SEND(0xAA);//PREAMBLE
	CALL SUBOPT_0x12
; 0000 01EE   RF12_SEND(0xAA);//PREAMBLE
	CALL SUBOPT_0x12
; 0000 01EF   RF12_SEND(0xAA);//PREAMBLE
	CALL SUBOPT_0x12
; 0000 01F0   RF12_SEND(0x2D);//SYNC HI BYTE
	LDI  R30,LOW(45)
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F1   RF12_SEND(0xD4);//SYNC LOW BYTE
	LDI  R30,LOW(212)
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F2   RF12_SEND(0x20);
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F3   RF12_SEND(0x6a);
	LDI  R30,LOW(106)
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F4   RF12_SEND(0x80);
	LDI  R30,LOW(128)
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F5   RF12_SEND(xas);
	LDS  R30,_xas
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F6   RF12_SEND(yas);
	LDS  R30,_yas
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01F7   RF12_SEND(ar2);
	ST   -Y,R19
	RCALL _RF12_SEND
; 0000 01F8   RF12_SEND(ar1);
	ST   -Y,R16
	RCALL _RF12_SEND
; 0000 01F9   RF12_SEND(ack);
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _RF12_SEND
; 0000 01FA   RF12_SEND(crc);
	ST   -Y,R17
	RCALL _RF12_SEND
; 0000 01FB   RF12_SEND(0xAA);//DUMMY BYTE
	CALL SUBOPT_0x12
; 0000 01FC   RF12_SEND(0xAA);//DUMMY BYTE
	CALL SUBOPT_0x12
; 0000 01FD   };
	CALL __LOADLOCR4
	ADIW R28,5
	RET
;
;// Declare your global variables here
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0202 {
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0203 if (++intflag==100) intflag=0,rfto_flag=0;
	INC  R9
	LDI  R30,LOW(100)
	CP   R30,R9
	BRNE _0x77
	CLR  R9
	LDI  R30,LOW(0)
	STS  _rfto_flag,R30
; 0000 0204 
; 0000 0205 }
_0x77:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;void main(void)
; 0000 0208 {
_main:
; 0000 0209 // Declare your local variables here
; 0000 020A 
; 0000 020B // Input/Output Ports initialization
; 0000 020C // Port A initialization
; 0000 020D // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=In Func1=In Func0=In
; 0000 020E // State7=T State6=T State5=T State4=0 State3=0 State2=T State1=T State0=T
; 0000 020F PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0210 DDRA=0x18;
	LDI  R30,LOW(24)
	OUT  0x1A,R30
; 0000 0211 
; 0000 0212 // Port B initialization
; 0000 0213 // Func7=Out Func6=In Func5=Out Func4=Out Func3=Out Func2=In Func1=Out Func0=Out
; 0000 0214 // State7=0 State6=P State5=0 State4=1 State3=0 State2=P State1=0 State0=0
; 0000 0215 PORTB=0x54;
	LDI  R30,LOW(84)
	OUT  0x18,R30
; 0000 0216 DDRB=0xBB;
	LDI  R30,LOW(187)
	OUT  0x17,R30
; 0000 0217 
; 0000 0218 // Port C initialization
; 0000 0219 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 021A // State7=T State6=T State5=P State4=P State3=P State2=P State1=P State0=P
; 0000 021B PORTC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x15,R30
; 0000 021C DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 021D 
; 0000 021E // Port D initialization
; 0000 021F // Func7=Out Func6=Out Func5=Out Func4=In Func3=In Func2=In Func1=Out Func0=In
; 0000 0220 // State7=0 State6=1 State5=0 State4=T State3=P State2=P State1=0 State0=P
; 0000 0221 PORTD=0x4D;
	LDI  R30,LOW(77)
	OUT  0x12,R30
; 0000 0222 DDRD=0xE2;
	LDI  R30,LOW(226)
	OUT  0x11,R30
; 0000 0223 
; 0000 0224 // Timer/Counter 0 initialization
; 0000 0225 // Clock source: System Clock
; 0000 0226 // Clock value: 12,695 kHz
; 0000 0227 // Mode: Normal top=FFh
; 0000 0228 // OC0 output: Disconnected
; 0000 0229 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 022A //TCCR0=0x00;
; 0000 022B TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 022C OCR0=0x80;
	LDI  R30,LOW(128)
	OUT  0x3C,R30
; 0000 022D 
; 0000 022E // Timer/Counter 1 initialization
; 0000 022F // Clock source: System Clock
; 0000 0230 // Clock value: 13000,000 kHz
; 0000 0231 // Mode: CTC top=OCR1A
; 0000 0232 // OC1A output: Toggle
; 0000 0233 // OC1B output: Discon.
; 0000 0234 // Noise Canceler: Off
; 0000 0235 // Input Capture on Falling Edge
; 0000 0236 // Timer1 Overflow Interrupt: Off
; 0000 0237 // Input Capture Interrupt: Off
; 0000 0238 // Compare A Match Interrupt: Off
; 0000 0239 // Compare B Match Interrupt: Off
; 0000 023A TCCR1A=0x40;
	LDI  R30,LOW(64)
	OUT  0x2F,R30
; 0000 023B TCCR1B=0x09;
	LDI  R30,LOW(9)
	OUT  0x2E,R30
; 0000 023C TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 023D TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 023E ICR1H=0x00;
	OUT  0x27,R30
; 0000 023F ICR1L=0x00;
	OUT  0x26,R30
; 0000 0240 OCR1AH=0x32;
	LDI  R30,LOW(50)
	OUT  0x2B,R30
; 0000 0241 OCR1AL=0xC8;
	LDI  R30,LOW(200)
	OUT  0x2A,R30
; 0000 0242 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 0243 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0244 
; 0000 0245 // Timer/Counter 2 initialization
; 0000 0246 // Clock source: TOSC1 pin
; 0000 0247 // Clock value: PCK2/32
; 0000 0248 // Mode: Normal top=FFh
; 0000 0249 // OC2 output: Disconnected
; 0000 024A ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
; 0000 024B TCCR2=0x03;
	LDI  R30,LOW(3)
	OUT  0x25,R30
; 0000 024C TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 024D OCR2=0x00;
	OUT  0x23,R30
; 0000 024E 
; 0000 024F 
; 0000 0250 // External Interrupt(s) initialization
; 0000 0251 // INT0: On
; 0000 0252 // INT0 Mode: Falling Edge
; 0000 0253 // INT1: Off
; 0000 0254 // INT2: Off
; 0000 0255 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
; 0000 0256 MCUCR=0x02;
	LDI  R30,LOW(2)
	OUT  0x35,R30
; 0000 0257 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
; 0000 0258 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
; 0000 0259 
; 0000 025A // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 025B TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 025C 
; 0000 025D // USART initialization
; 0000 025E // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 025F // USART Receiver: On
; 0000 0260 // USART Transmitter: On
; 0000 0261 // USART Mode: Asynchronous
; 0000 0262 // USART Baud Rate: 115200
; 0000 0263 UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 0264 UCSRB=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
; 0000 0265 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 0266 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0267 UBRRL=0x06;
	LDI  R30,LOW(6)
	OUT  0x9,R30
; 0000 0268 
; 0000 0269 // Analog Comparator initialization
; 0000 026A // Analog Comparator: Off
; 0000 026B // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 026C ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 026D SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 026E 
; 0000 026F // ADC initialization
; 0000 0270 // ADC Clock frequency: 812,500 kHz
; 0000 0271 // ADC Voltage Reference: AVCC pin
; 0000 0272 // ADC Auto Trigger Source: None
; 0000 0273 // Only the 8 most significant bits of
; 0000 0274 // the AD conversion result are used
; 0000 0275 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(96)
	OUT  0x7,R30
; 0000 0276 ADCSRA=0x84;
	LDI  R30,LOW(132)
	OUT  0x6,R30
; 0000 0277 
; 0000 0278 // I2C Bus initialization
; 0000 0279 i2c_init();
	CALL _i2c_init
; 0000 027A PORTD.6=0;//
	CBI  0x12,6
; 0000 027B //
; 0000 027C if (PINC.5) delay_ms(1000);
	SBIS 0x13,5
	RJMP _0x7A
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x8
; 0000 027D if (PINC.5) PORTD.7=1;
_0x7A:
	SBIC 0x13,5
	SBI  0x12,7
; 0000 027E 
; 0000 027F 
; 0000 0280 GPM388CO_init();
	RCALL _GPM388CO_init
; 0000 0281 // FRM12
; 0000 0282 RF12_INIT();
	RCALL _RF12_INIT
; 0000 0283 RF12_rx_on();
	RCALL _RF12_rx_on
; 0000 0284 
; 0000 0285 // 
; 0000 0286 t.tick=0;t.second=0;t.minute=0;t.hour=0;
	LDI  R30,LOW(0)
	STS  _t,R30
	__PUTB1MN _t,1
	__PUTB1MN _t,2
	__PUTB1MN _t,3
; 0000 0287 // Global enable interrupts
; 0000 0288 #asm("sei")
	sei
; 0000 0289 
; 0000 028A while (1)
_0x7E:
; 0000 028B       {
; 0000 028C        if ((reg==0)||(reg==1)) {
	LDI  R30,LOW(0)
	CP   R30,R5
	BREQ _0x82
	LDI  R30,LOW(1)
	CP   R30,R5
	BRNE _0x81
_0x82:
; 0000 028D        sleep_enable();  //  SLEEP.
	CALL _sleep_enable
; 0000 028E        powersave();       //  .
	CALL _powersave
; 0000 028F        sleep_disable(); //  SLEEP.
; 0000 0290        }
; 0000 0291        else sleep_disable(); //  SLEEP.
_0x81:
_0xFE:
	CALL _sleep_disable
; 0000 0292 
; 0000 0293              // 
; 0000 0294         inkey=keypress();
	RCALL _keypress
	MOV  R11,R30
; 0000 0295         if (inkey!=0x3f)
	LDI  R30,LOW(63)
	CP   R30,R11
	BREQ _0x85
; 0000 0296         {
; 0000 0297         itoa (inkey,stroka),LcdPutLine(stroka,5,18,0);
	MOV  R30,R11
	CALL SUBOPT_0x13
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(18)
	CALL SUBOPT_0xE
; 0000 0298         for (i=0;i<12;i++) write_column(0x00);
_0x87:
	LDI  R30,LOW(12)
	CP   R6,R30
	BRSH _0x88
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0x87
_0x88:
; 0000 0299 };
_0x85:
; 0000 029A           if (inkey==keysettime) regold=0,reg=8;
	LDI  R30,LOW(65)
	CP   R30,R11
	BRNE _0x89
	CLR  R4
	LDI  R30,LOW(8)
	MOV  R5,R30
; 0000 029B           if (inkey==keyc) PORTA.3=!PORTA.3; //
_0x89:
	LDI  R30,LOW(6)
	CP   R30,R11
	BRNE _0x8A
	SBIS 0x1B,3
	RJMP _0x8B
	CBI  0x1B,3
	RJMP _0x8C
_0x8B:
	SBI  0x1B,3
_0x8C:
; 0000 029C           if (inkey==0x56)
_0x8A:
	LDI  R30,LOW(86)
	CP   R30,R11
	BRNE _0x8D
; 0000 029D            {
; 0000 029E             regold=0,reg=9; //  9  
	CLR  R4
	LDI  R30,LOW(9)
	MOV  R5,R30
; 0000 029F             RF12_tx_on();
	RCALL _RF12_tx_on
; 0000 02A0            };
_0x8D:
; 0000 02A1           if (inkey==0x51)
	LDI  R30,LOW(81)
	CP   R30,R11
	BRNE _0x8E
; 0000 02A2            {
; 0000 02A3             regold=0,reg=7; //  7    
	CLR  R4
	LDI  R30,LOW(7)
	MOV  R5,R30
; 0000 02A4             RF12_rx_on();
	RCALL _RF12_rx_on
; 0000 02A5            };
_0x8E:
; 0000 02A6           if (inkey==0x58)
	LDI  R30,LOW(88)
	CP   R30,R11
	BRNE _0x8F
; 0000 02A7            {
; 0000 02A8            regold=0,reg=6; //  6   
	CLR  R4
	LDI  R30,LOW(6)
	MOV  R5,R30
; 0000 02A9            RF12_rx_on();
	RCALL _RF12_rx_on
; 0000 02AA            };
_0x8F:
; 0000 02AB 
; 0000 02AC         //   
; 0000 02AD        showtime ();
	RCALL _showtime
; 0000 02AE 
; 0000 02AF        if (reg==0)  //   
	TST  R5
	BRNE _0x90
; 0000 02B0        {
; 0000 02B1        regold=0;
	CLR  R4
; 0000 02B2        };
_0x90:
; 0000 02B3          //  
; 0000 02B4        if (PIND.4)
	SBIS 0x10,4
	RJMP _0x91
; 0000 02B5          {
; 0000 02B6          if (reg!=1) regold=reg;
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ _0x92
	MOV  R4,R5
; 0000 02B7          reg=1;
_0x92:
	LDI  R30,LOW(1)
	MOV  R5,R30
; 0000 02B8          }
; 0000 02B9 
; 0000 02BA 
; 0000 02BB        if (reg==1)   //   
_0x91:
	LDI  R30,LOW(1)
	CP   R30,R5
	BREQ PC+3
	JMP _0x93
; 0000 02BC        {
; 0000 02BD          if ((PIND.4)&(read_adc(2)>0x09))
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	PUSH R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R26,R30
	LDI  R30,LOW(9)
	CALL __GTB12U
	POP  R26
	AND  R30,R26
	BREQ _0x94
; 0000 02BE          {
; 0000 02BF          sms[0]=0x81;
	LDI  R30,LOW(129)
	STS  _sms,R30
; 0000 02C0          sms[1]=0x20;
	LDI  R30,LOW(32)
	__PUTB1MN _sms,1
; 0000 02C1          LcdPutLine(tst[1],3,18,0);
	__POINTW1MN _tst,10
	CALL SUBOPT_0x14
; 0000 02C2          }
; 0000 02C3         if ((PIND.4)&(read_adc(2)<0x0a))
_0x94:
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	PUSH R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _read_adc
	MOV  R26,R30
	LDI  R30,LOW(10)
	CALL __LTB12U
	POP  R26
	AND  R30,R26
	BREQ _0x95
; 0000 02C4          {
; 0000 02C5          sms[0]=0x46;
	LDI  R30,LOW(70)
	STS  _sms,R30
; 0000 02C6          sms[1]=0x4c;
	LDI  R30,LOW(76)
	CALL SUBOPT_0x15
; 0000 02C7          LcdPutLine(tst[0],3,18,0);
; 0000 02C8          };
_0x95:
; 0000 02C9         if (!PIND.4)
	SBIC 0x10,4
	RJMP _0x96
; 0000 02CA          {
; 0000 02CB          sms[0]=0x20;
	LDI  R30,LOW(32)
	STS  _sms,R30
; 0000 02CC          sms[1]=0x20;
	CALL SUBOPT_0x15
; 0000 02CD 
; 0000 02CE          LcdPutLine(tst[0],3,18,0);
; 0000 02CF          if (!regold) PORTD.7=0;
	TST  R4
	BRNE _0x97
	CBI  0x12,7
; 0000 02D0          else reg=regold;
	RJMP _0x9A
_0x97:
	MOV  R5,R4
; 0000 02D1          };
_0x9A:
_0x96:
; 0000 02D2          sms[2]=0x00;
	LDI  R30,LOW(0)
	__PUTB1MN _sms,2
; 0000 02D3          LcdPutLine(sms,0,90,0);
	LDI  R30,LOW(_sms)
	LDI  R31,HIGH(_sms)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(90)
	CALL SUBOPT_0x16
; 0000 02D4 
; 0000 02D5         };
_0x93:
; 0000 02D6 
; 0000 02D7        if (reg==8)   //   
	LDI  R30,LOW(8)
	CP   R30,R5
	BREQ PC+3
	JMP _0x9B
; 0000 02D8        {
; 0000 02D9         LcdPutLine(tst[8],3,18,0);
	__POINTW1MN _tst,80
	CALL SUBOPT_0x14
; 0000 02DA         inkey=keypress();
	RCALL _keypress
	MOV  R11,R30
; 0000 02DB         if ((inkey==keyl)&(t.hour<24)) t.hour++;
	MOV  R26,R11
	LDI  R30,LOW(8)
	CALL __EQB12
	MOV  R0,R30
	__GETB2MN _t,3
	LDI  R30,LOW(24)
	CALL __LTB12U
	AND  R30,R0
	BREQ _0x9C
	__GETB1MN _t,3
	SUBI R30,-LOW(1)
	__PUTB1MN _t,3
	SUBI R30,LOW(1)
; 0000 02DC         if (t.hour==24) t.hour=0;
_0x9C:
	__GETB2MN _t,3
	CPI  R26,LOW(0x18)
	BRNE _0x9D
	LDI  R30,LOW(0)
	__PUTB1MN _t,3
; 0000 02DD         if ((inkey==keyu)&(t.minute<60)) t.minute=t.minute+10;
_0x9D:
	MOV  R26,R11
	LDI  R30,LOW(2)
	CALL SUBOPT_0x17
	BREQ _0x9E
	__GETB1MN _t,2
	SUBI R30,-LOW(10)
	__PUTB1MN _t,2
; 0000 02DE         if ((inkey==keyr)&(t.minute<60)) t.minute++;
_0x9E:
	MOV  R26,R11
	LDI  R30,LOW(1)
	CALL SUBOPT_0x17
	BREQ _0x9F
	__GETB1MN _t,2
	SUBI R30,-LOW(1)
	__PUTB1MN _t,2
	SUBI R30,LOW(1)
; 0000 02DF         if (t.minute>59) t.minute=0;
_0x9F:
	__GETB2MN _t,2
	CPI  R26,LOW(0x3C)
	BRLO _0xA0
	LDI  R30,LOW(0)
	__PUTB1MN _t,2
; 0000 02E0         if (inkey==0x50) reg=regold,LcdPutLine(tst[0],3,18,0);// 
_0xA0:
	LDI  R30,LOW(80)
	CP   R30,R11
	BRNE _0xA1
	MOV  R5,R4
	CALL SUBOPT_0x18
; 0000 02E1         tflag=1;
_0xA1:
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 02E2 
; 0000 02E3        };
_0x9B:
; 0000 02E4 
; 0000 02E5        if (reg==9)   //  
	LDI  R30,LOW(9)
	CP   R30,R5
	BREQ PC+3
	JMP _0xA2
; 0000 02E6        {
; 0000 02E7          //
; 0000 02E8        yin=(read_adc(6))-75;
	LDI  R30,LOW(6)
	CALL SUBOPT_0x19
	SUBI R30,LOW(75)
	SBCI R31,HIGH(75)
	STS  _yin,R30
; 0000 02E9        xin=(read_adc(1))-79;
	LDI  R30,LOW(1)
	CALL SUBOPT_0x19
	SUBI R30,LOW(79)
	SBCI R31,HIGH(79)
	STS  _xin,R30
; 0000 02EA 
; 0000 02EB        itoa (yas,stroka),LcdPutLine(stroka,7,20,0);
	LDS  R30,_yas
	CALL SUBOPT_0x13
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(20)
	CALL SUBOPT_0xE
; 0000 02EC        for (i=0;i<12;i++) write_column(0x00);
_0xA4:
	LDI  R30,LOW(12)
	CP   R6,R30
	BRSH _0xA5
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0xA4
_0xA5:
; 0000 02ED LcdBarLine(yas<<1,7,32);
	LDS  R30,_yas
	LSL  R30
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _LcdBarLine
; 0000 02EE        itoa (xas,stroka),LcdPutLine(stroka,6,20,0);
	LDS  R30,_xas
	CALL SUBOPT_0x13
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(20)
	CALL SUBOPT_0xE
; 0000 02EF        for (i=0;i<12;i++) write_column(0x00);
_0xA7:
	LDI  R30,LOW(12)
	CP   R6,R30
	BRSH _0xA8
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0xA7
_0xA8:
; 0000 02F0 LcdBarLine(xas<<1,6,32);
	LDS  R30,_xas
	LSL  R30
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _LcdBarLine
; 0000 02F1        rtx_pack(0x20);
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _rtx_pack
; 0000 02F2         if ((xas<31)&&(xin>75)) xas++;
	LDS  R26,_xas
	CPI  R26,LOW(0x1F)
	BRSH _0xAA
	LDS  R26,_xin
	CPI  R26,LOW(0x4C)
	BRSH _0xAB
_0xAA:
	RJMP _0xA9
_0xAB:
	LDS  R30,_xas
	SUBI R30,-LOW(1)
	STS  _xas,R30
; 0000 02F3         if ((xas>1)&&(xin<25)) xas--;
_0xA9:
	LDS  R26,_xas
	CPI  R26,LOW(0x2)
	BRLO _0xAD
	LDS  R26,_xin
	CPI  R26,LOW(0x19)
	BRLO _0xAE
_0xAD:
	RJMP _0xAC
_0xAE:
	LDS  R30,_xas
	SUBI R30,LOW(1)
	STS  _xas,R30
; 0000 02F4         if ((yas<31)&&(yin>82)) yas++;
_0xAC:
	LDS  R26,_yas
	CPI  R26,LOW(0x1F)
	BRSH _0xB0
	LDS  R26,_yin
	CPI  R26,LOW(0x53)
	BRSH _0xB1
_0xB0:
	RJMP _0xAF
_0xB1:
	LDS  R30,_yas
	SUBI R30,-LOW(1)
	STS  _yas,R30
; 0000 02F5         if ((yas>1)&&(yin<40)) yas--;
_0xAF:
	LDS  R26,_yas
	CPI  R26,LOW(0x2)
	BRLO _0xB3
	LDS  R26,_yin
	CPI  R26,LOW(0x28)
	BRLO _0xB4
_0xB3:
	RJMP _0xB2
_0xB4:
	LDS  R30,_yas
	SUBI R30,LOW(1)
	STS  _yas,R30
; 0000 02F6         if ((xas>16)&&((xin<75)&&(xin>25))) xas--;
_0xB2:
	LDS  R26,_xas
	CPI  R26,LOW(0x11)
	BRLO _0xB6
	LDS  R26,_xin
	CPI  R26,LOW(0x4B)
	BRSH _0xB7
	CPI  R26,LOW(0x1A)
	BRSH _0xB8
_0xB7:
	RJMP _0xB6
_0xB8:
	RJMP _0xB9
_0xB6:
	RJMP _0xB5
_0xB9:
	LDS  R30,_xas
	SUBI R30,LOW(1)
	STS  _xas,R30
; 0000 02F7         if ((xas<16)&&((xin<75)&&(xin>25))) xas++;
_0xB5:
	LDS  R26,_xas
	CPI  R26,LOW(0x10)
	BRSH _0xBB
	LDS  R26,_xin
	CPI  R26,LOW(0x4B)
	BRSH _0xBC
	CPI  R26,LOW(0x1A)
	BRSH _0xBD
_0xBC:
	RJMP _0xBB
_0xBD:
	RJMP _0xBE
_0xBB:
	RJMP _0xBA
_0xBE:
	LDS  R30,_xas
	SUBI R30,-LOW(1)
	STS  _xas,R30
; 0000 02F8         if (inkey==0x50)           //  
_0xBA:
	LDI  R30,LOW(80)
	CP   R30,R11
	BRNE _0xBF
; 0000 02F9         {
; 0000 02FA          set_row_clm(6,20);
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(20)
	ST   -Y,R30
	RCALL _set_row_clm
; 0000 02FB          for (i=0;i<180;i++) write_column(0x00);
	CLR  R6
_0xC1:
	LDI  R30,LOW(180)
	CP   R6,R30
	BRSH _0xC2
	CALL SUBOPT_0xB
	INC  R6
	RJMP _0xC1
_0xC2:
; 0000 02FC reg=regold,slen=1,LcdPutLine(tst[0],3,18,0);
	MOV  R5,R4
	LDI  R30,LOW(1)
	STS  _slen,R30
	CALL SUBOPT_0x18
; 0000 02FD          RF12_rx_on();
	RCALL _RF12_rx_on
; 0000 02FE         };
_0xBF:
; 0000 02FF         };
_0xA2:
; 0000 0300 
; 0000 0301        if (reg==7)      //   
	LDI  R30,LOW(7)
	CP   R30,R5
	BREQ PC+3
	JMP _0xC3
; 0000 0302        {
; 0000 0303          w0=0;w1=0;crc_in=0;
	LDI  R30,LOW(0)
	STS  _w0,R30
	STS  _w1,R30
	STS  _crc_in,R30
; 0000 0304 lb1:       //clear_lcd();
_0xC4:
; 0000 0305            while (!(data_rf==0x2D)&&rfto_flag) {rfxx_flag=1;};
_0xC5:
	LDS  R26,_data_rf
	CPI  R26,LOW(0x2D)
	BREQ _0xC8
	LDS  R30,_rfto_flag
	CPI  R30,0
	BRNE _0xC9
_0xC8:
	RJMP _0xC7
_0xC9:
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
	RJMP _0xC5
_0xC7:
; 0000 0306            if (!rfto_flag) goto lb2;
	LDS  R30,_rfto_flag
	CPI  R30,0
	BRNE _0xCA
	RJMP _0xCB
; 0000 0307            rfxx_flag=1;
_0xCA:
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
; 0000 0308            while (rfxx_flag) {};
_0xCC:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xCC
; 0000 0309            rfxx_flag=1;
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
; 0000 030A            while (rfxx_flag) {};
_0xCF:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xCF
; 0000 030B            rfxx_flag=1;
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
; 0000 030C            while (rfxx_flag) {};      //  
_0xD2:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xD2
; 0000 030D            rfxx_flag=1;
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
; 0000 030E           while (rfxx_flag) {};
_0xD5:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xD5
; 0000 030F           inbuff[0]=data_rf,rfxx_flag=1,crc_in=inbuff[0]%0x31;
	LDS  R30,_data_rf
	STS  _inbuff,R30
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
	LDS  R26,_inbuff
	CLR  R27
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	CALL __MODW21
	STS  _crc_in,R30
; 0000 0310           while (rfxx_flag) {};
_0xD8:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xD8
; 0000 0311           inbuff[1]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[1])%0x31;
	LDS  R30,_data_rf
	__PUTB1MN _inbuff,1
	CALL SUBOPT_0x1A
	__GETB1MN _inbuff,1
	CALL SUBOPT_0x11
	STS  _crc_in,R30
; 0000 0312           while (rfxx_flag) {};
_0xDB:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xDB
; 0000 0313           inbuff[2]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[2])%0x31;
	LDS  R30,_data_rf
	__PUTB1MN _inbuff,2
	CALL SUBOPT_0x1A
	__GETB1MN _inbuff,2
	CALL SUBOPT_0x11
	STS  _crc_in,R30
; 0000 0314           while (rfxx_flag) {};
_0xDE:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xDE
; 0000 0315           inbuff[3]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[3])%0x31;
	LDS  R30,_data_rf
	__PUTB1MN _inbuff,3
	CALL SUBOPT_0x1A
	__GETB1MN _inbuff,3
	CALL SUBOPT_0x11
	STS  _crc_in,R30
; 0000 0316           while (rfxx_flag) {};
_0xE1:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xE1
; 0000 0317           inbuff[4]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[4])%0x31;
	LDS  R30,_data_rf
	__PUTB1MN _inbuff,4
	CALL SUBOPT_0x1A
	__GETB1MN _inbuff,4
	CALL SUBOPT_0x11
	STS  _crc_in,R30
; 0000 0318           while (rfxx_flag) {};
_0xE4:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xE4
; 0000 0319           inbuff[5]=data_rf,rfxx_flag=1,crc_in=(crc_in+inbuff[5])%0x31;
	LDS  R30,_data_rf
	__PUTB1MN _inbuff,5
	CALL SUBOPT_0x1A
	__GETB1MN _inbuff,5
	CALL SUBOPT_0x11
	STS  _crc_in,R30
; 0000 031A           while (rfxx_flag) {};
_0xE7:
	LDS  R30,_rfxx_flag
	CPI  R30,0
	BRNE _0xE7
; 0000 031B           inbuff[6]=data_rf,rfxx_flag=1;
	LDS  R30,_data_rf
	__PUTB1MN _inbuff,6
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
; 0000 031C 
; 0000 031D           if (!(inbuff[6]==crc_in)) goto lb1;  // 
	__GETB1MN _inbuff,6
	LDS  R26,_crc_in
	CP   R30,R26
	BREQ _0xEA
	RJMP _0xC4
; 0000 031E 
; 0000 031F lb2:      rfto_flag=1,intflag=0;
_0xEA:
_0xCB:
	LDI  R30,LOW(1)
	STS  _rfto_flag,R30
	CLR  R9
; 0000 0320          // itoa (intflag,stroka),LcdPutLine(stroka,0,80,0);
; 0000 0321           itoa (inbuff[0],stroka),LcdPutLine(stroka,1,20,0),probel();
	LDS  R30,_inbuff
	CALL SUBOPT_0x13
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1B
	RCALL _probel
; 0000 0322           itoa (inbuff[1],stroka),LcdPutLine(stroka,1,60,0),probel();
	__GETB1MN _inbuff,1
	CALL SUBOPT_0x13
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1C
	RCALL _probel
; 0000 0323           itoa (inbuff[2],stroka),LcdPutLine(stroka,2,20,0),probel();
	__GETB1MN _inbuff,2
	CALL SUBOPT_0x13
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1B
	RCALL _probel
; 0000 0324           itoa (inbuff[3],stroka),LcdPutLine(stroka,2,60,0),probel();
	__GETB1MN _inbuff,3
	CALL SUBOPT_0x13
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1C
	RCALL _probel
; 0000 0325           itoa (inbuff[4],stroka),LcdPutLine(stroka,3,20,0),probel();
	__GETB1MN _inbuff,4
	CALL SUBOPT_0x13
	LDI  R30,LOW(3)
	CALL SUBOPT_0x1B
	RCALL _probel
; 0000 0326           itoa (inbuff[6],stroka),LcdPutLine(stroka,3,60,0),probel();
	__GETB1MN _inbuff,6
	CALL SUBOPT_0x13
	LDI  R30,LOW(3)
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1D
; 0000 0327 
; 0000 0328           itoa (read_adc(5),stroka),LcdPutLine(stroka,5,60,0),probel();
	LDI  R30,LOW(5)
	CALL SUBOPT_0x1C
	RCALL _probel
; 0000 0329           if (inkey==0x10)
	LDI  R30,LOW(16)
	CP   R30,R11
	BRNE _0xEB
; 0000 032A         {
; 0000 032B          inkey=0x3f;clear_lcd();
	LDI  R30,LOW(63)
	MOV  R11,R30
	RCALL _clear_lcd
; 0000 032C          reg=0;
	CLR  R5
; 0000 032D         };
_0xEB:
; 0000 032E        };
_0xC3:
; 0000 032F 
; 0000 0330 
; 0000 0331        if (reg==6)      //    
	LDI  R30,LOW(6)
	CP   R30,R5
	BRNE _0xEC
; 0000 0332        {
; 0000 0333          while((rfxx_flag==1)&&PINC.4&&rfto_flag);
_0xED:
	LDS  R26,_rfxx_flag
	CPI  R26,LOW(0x1)
	BRNE _0xF0
	SBIS 0x13,4
	RJMP _0xF0
	LDS  R30,_rfto_flag
	CPI  R30,0
	BRNE _0xF1
_0xF0:
	RJMP _0xEF
_0xF1:
	RJMP _0xED
_0xEF:
; 0000 0334          rfxx_flag=1,rfto_flag=1;
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
	STS  _rfto_flag,R30
; 0000 0335          itoa (data_rf,stroka),LcdPutLine(stroka,6,60,0),probel();
	LDS  R30,_data_rf
	CALL SUBOPT_0x13
	LDI  R30,LOW(6)
	CALL SUBOPT_0x1C
	RCALL _probel
; 0000 0336          itoa (status_rf,stroka),LcdPutLine(stroka,6,10,0),probel();
	LDS  R30,_status_rf
	LDS  R31,_status_rf+1
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_stroka)
	LDI  R31,HIGH(_stroka)
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
	LDI  R30,LOW(_stroka)
	LDI  R31,HIGH(_stroka)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(10)
	CALL SUBOPT_0x16
	CALL SUBOPT_0x1D
; 0000 0337          itoa (read_adc(5),stroka),LcdPutLine(stroka,5,60,0),probel();
	LDI  R30,LOW(5)
	CALL SUBOPT_0x1C
	RCALL _probel
; 0000 0338          if (inkey==0x50)
	LDI  R30,LOW(80)
	CP   R30,R11
	BRNE _0xF2
; 0000 0339            {
; 0000 033A             inkey=0x3f;clear_lcd();
	LDI  R30,LOW(63)
	MOV  R11,R30
	RCALL _clear_lcd
; 0000 033B             reg=0;
	CLR  R5
; 0000 033C            };
_0xF2:
; 0000 033D         };
_0xEC:
; 0000 033E 
; 0000 033F          if (inkey==0x50)
	LDI  R30,LOW(80)
	CP   R30,R11
	BRNE _0xF3
; 0000 0340         {
; 0000 0341          if (rfm) PORTA.3=0,PORTD.7=0;
	LDS  R30,_rfm
	CPI  R30,0
	BREQ _0xF4
	CBI  0x1B,3
	CBI  0x12,7
; 0000 0342          if (reg==0) rfm=1;
_0xF4:
	TST  R5
	BRNE _0xF9
	LDI  R30,LOW(1)
	RJMP _0xFF
; 0000 0343          else rfm=0;
_0xF9:
	LDI  R30,LOW(0)
_0xFF:
	STS  _rfm,R30
; 0000 0344          reg=0,LcdPutLine(tst[0],3,18,0);
	CLR  R5
	CALL SUBOPT_0x18
; 0000 0345         };
_0xF3:
; 0000 0346 
; 0000 0347       };
	RJMP _0x7E
; 0000 0348 }
_0xFB:
	RJMP _0xFB

	.CSEG
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret

	.DSEG

	.CSEG
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_sleep_enable:
   in   r30,power_ctrl_reg
   sbr  r30,__se_bit
   out  power_ctrl_reg,r30
	RET
_sleep_disable:
   in   r30,power_ctrl_reg
   cbr  r30,__se_bit
   out  power_ctrl_reg,r30
	RET
_powersave:
   in   r30,power_ctrl_reg
   cbr  r30,__sm_mask
   sbr  r30,__sm_powersave
   out  power_ctrl_reg,r30
   in   r30,sreg
   sei
   sleep
   out  sreg,r30
	RET
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_t:
	.BYTE 0x4
_stroka:
	.BYTE 0x4
_sms:
	.BYTE 0x3
_tst:
	.BYTE 0x64
_tkey:
	.BYTE 0x1
_slen:
	.BYTE 0x1
_data_rf:
	.BYTE 0x1
_rfxx_flag:
	.BYTE 0x1
_w0:
	.BYTE 0x1
_w1:
	.BYTE 0x1
_inbuff:
	.BYTE 0x7
_crc_in:
	.BYTE 0x1
_rfto_flag:
	.BYTE 0x1
_buffer:
	.BYTE 0x20
_xas:
	.BYTE 0x1
_yas:
	.BYTE 0x1
_xin:
	.BYTE 0x1
_yin:
	.BYTE 0x1
_rfm:
	.BYTE 0x1
_status_rf:
	.BYTE 0x2
_rx_buffer:
	.BYTE 0x20
_rx_wr_index:
	.BYTE 0x1
_rx_rd_index:
	.BYTE 0x1
_rx_counter:
	.BYTE 0x1
__seed_G100:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _RFXX_WRT_CMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(32999)
	LDI  R31,HIGH(32999)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _RFXX_WRT_CMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x2:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _RFXX_WRT_CMD

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3:
	CALL _i2c_start
	LDI  R30,LOW(120)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(40)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	CALL _i2c_write
	JMP  _i2c_stop

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(64)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(41)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xA:
	LDD  R30,Y+6
	ST   -Y,R30
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _set_row_clm
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _write_column

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	SBI  0x1B,4
	SBI  0x12,6
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:42 WORDS
SUBOPT_0xD:
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_stroka)
	LDI  R31,HIGH(_stroka)
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
	LDI  R30,LOW(_stroka)
	LDI  R31,HIGH(_stroka)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xE:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _LcdPutLine
	CLR  R6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xF:
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	CALL __MODW21
	MOV  R17,R30
	MOV  R26,R17
	CLR  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	CALL __MODW21
	MOV  R17,R30
	MOV  R26,R17
	CLR  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x11:
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(170)
	ST   -Y,R30
	JMP  _RF12_SEND

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:140 WORDS
SUBOPT_0x13:
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_stroka)
	LDI  R31,HIGH(_stroka)
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
	LDI  R30,LOW(_stroka)
	LDI  R31,HIGH(_stroka)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x14:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDI  R30,LOW(18)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _LcdPutLine

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	__PUTB1MN _sms,1
	LDI  R30,LOW(_tst)
	LDI  R31,HIGH(_tst)
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x16:
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _LcdPutLine

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x17:
	CALL __EQB12
	MOV  R0,R30
	__GETB2MN _t,2
	LDI  R30,LOW(60)
	CALL __LTB12U
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(_tst)
	LDI  R31,HIGH(_tst)
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	ST   -Y,R30
	CALL _read_adc
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(1)
	STS  _rfxx_flag,R30
	LDS  R26,_crc_in
	CLR  R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	ST   -Y,R30
	LDI  R30,LOW(20)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1C:
	ST   -Y,R30
	LDI  R30,LOW(60)
	RJMP SUBOPT_0x16

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1D:
	CALL _probel
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _read_adc
	RJMP SUBOPT_0x13


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,22
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,43
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xCB2
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
